/* File Eleonora.c from package Eleonora.tar.gz by Tharkas.      *
 *                Enjoy!					 */

#define __KERNEL__
#define MODULE


#include <linux/kernel.h>
#include <linux/module.h>

#include <linux/tty.h>
#include <linux/mm.h>

#include <asm/uaccess.h>
#include <sys/syscall.h>

#include <linux/time.h>

#include <linux/string.h>

#define mask st_mode

#define CONF_FILE "/etc/Eleonora/ele.conf"
#define LOG_FILE  "/etc/Eleonora/ele.log"
#define TTY_FILE  "/etc/Eleonora/tty.allow"

extern void *sys_call_table[];

char allowed[100][10];

void ttycredit(char *str, ...);
void log(char *str, ...);

#define TTY_NUMBER(tty) (MINOR((tty)->device) - (tty)->driver.minor_start + \
      (tty)->driver.name_base)

#define MOD_NAME "Eleonora"

int corrente[12] = { 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };

/* Section 1 */
int (*old_open) (char *, int, int);
int (*old_unlink) (char *);
int (*old_rmdir) (char *);
int (*old_chdir) (char *);

/* Section 2 */
int (*old_setuid) (int);
int (*old_setgid) (int);

/* Section 3 */
int (*old_socketcall) (int, unsigned long *);

/* Section 4 */
caddr_t (*old_create_module) (char *, int);
int (*old_delete_module) (char *);

/* Section 5 */
int (*old_execve) (struct pt_regs);

int (*stat) (char *, struct stat *);
int (*fstat) (int, struct stat *);
int (*close) (int);
int (*readlink) (char *, char *, int);
int (*read) (int, void *, int);
int (*write) (int, void *, int);
time_t (*time) (time_t *);
int (*getpid) (void);
int (*getuid) (void);
int (*getgid) (void);

int isdigit(char a) {
  if (a == '0')
   return 1;
  if (a == '1')
   return 1;
  if (a == '2')
   return 1;
  if (a == '3')
   return 1;
  if (a == '4')
   return 1;
  if (a == '5')
   return 1;
  if (a == '6')
   return 1;
  if (a == '7')
   return 1;
  if (a == '8')
   return 1;
  if (a == '9')
   return 1;

return 0;

}

struct ele_opt {

        short locked_files;
        short deny_vcss;
        short deny_ttys;
        short remote_root;
        short socket_root_only;
        short no_binding;
        short protection_type;
        short no_daemon_sh; // Unused, at the moment.
        short logging;
        short deny_other_mods;
        unsigned int minimum_id;
        unsigned int id_redirect;


};

struct ele_opt options;

char b[100];

char *gttyname() {
mm_segment_t old;
char a[100];

  old = current->addr_limit;
  current->addr_limit = KERNEL_DS;

   sprintf(a, "/proc/%d/fd/0", getpid());

   readlink(a, b, 100);

   current->addr_limit = old;

   return (char *) &b;

}

char *gnamebypid(int pid) {
char buf[25];
mm_segment_t old;
char readme[50];
int fd;
char *ptr;
int x;

  old = current->addr_limit;
  current->addr_limit = KERNEL_DS;

  sprintf(buf, "/proc/%d/status", getpid());

  fd = old_open(buf, O_RDONLY, 0);
   if (fd < 0)
     return "UNKNOWN";

  read(fd, readme, 50);

  close(fd);

  ptr = strchr(readme, '\t');
  ptr += 1;

 for(x=0;;x++) {
   if (x > 50)
    break;
   if (*(ptr + x) == '\n')
    memset(ptr+x, 0, 50-x);
 }

current->addr_limit = old;

  return ptr;

}

int gttynum() {
mm_segment_t old;
char a[100];
char num[10];
int x = 0;
int l = 0;

  old = current->addr_limit;
  current->addr_limit = KERNEL_DS;

   sprintf(a, "/proc/%d/fd/0", getpid());

   readlink(a, b, 100);

for(x = 0; b[x]; x++) {
  if (isdigit(b[x])) {
    num[l] = b[x];
    ++l;
  }
}

   current->addr_limit = old;

   return atoi(num);

}

int get_allowed_tty() {
int fd;
mm_segment_t old;
int c = 0;

   old = current->addr_limit;
   current->addr_limit = KERNEL_DS;

   fd = old_open(TTY_FILE, O_RDONLY, 0);
    if (fd < 0)
     return -1;

   while(read(fd, allowed[c], 10)) {
     allowed[c][strlen(allowed[c] - 1)] = '\0';
     c++;
   }

return 1;

}

int fill_opt() {
int fd;
mm_segment_t old;
int res;

  old = current->addr_limit;
  current->addr_limit = KERNEL_DS;

    fd = old_open(CONF_FILE, O_RDONLY, 0);

   if (fd < 0)
    return -1;

   res = read(fd, &options, sizeof(struct ele_opt));

   if (res < 0)
    return -1;

   if (res < sizeof(struct ele_opt))
    return -1;

  close(fd);

  current->addr_limit = old;

  return 1;

}

int atoi(char str[])
{
    int res = 0;
    int i ;
    for(i = 0; str[i] >='0' && str[i] <='9'; ++i)
        res = 10 * res + str[i] - '0';
    return res;
}

/*****************************************************************
 * Here begins the section 1 (see the readme file)               *
 *****************************************************************/

int new_open(char *a, int b, int c) {
mm_segment_t old;
struct stat *st;
int fd;
char toread[20];
char readto[100];
char num[2];
int ttyn = 0;
char name[50];

  memset(toread, 0, 20);
  memset(readto, 0, 100);

  old = current->addr_limit;
  current->addr_limit = KERNEL_DS;

  fd = old_open(a, b, c);

 if (fd < 0)
   return fd;

 sprintf(toread, "/proc/%d/fd/%d",getpid(), fd);

 readlink(toread, readto, 100);

  if (readto[0] != '\0') {

if (options.deny_vcss) {

    if (!strncmp(readto, "/dev/vcsa", 9)) {
     ttyn = gttynum();
     if (ttyn) {
      num[0] = readto[9];
       if (readto[10] != '\0')
      num[1] = readto[10];
       if (atoi(num) != ttyn) {
         close(fd);
         current->addr_limit = old;
         strncpy(name,gnamebypid(getpid()),50);
         log("Program %s from %s (%d/%d) tried to access %s. Blocked.",name, gttyname(), getuid(), getgid(), readto);
         return -EPERM;
       }
     }
    }
    else if (!strncmp(readto, "/dev/vcs", 8)) {
     ttyn = gttynum();
     if (ttyn) {
      num[0] = readto[8];
       if (readto[9] != '\0')
      num[1] = readto[9];
       if (atoi(num) != ttyn) {
         close(fd);
         current->addr_limit = old;
         strncpy(name,gnamebypid(getpid()),50);
         log("Program %s from %s (%d/%d) tried to access %s. Blocked.",name, gttyname(), getuid(), getgid(), readto);
         return -EPERM;
       }
     }
    }
}

if (options.deny_ttys) {
    if (!strncmp(readto, "/dev/tty", 8)) {
     ttyn = gttynum();
     if (ttyn) {
      num[0] = readto[8];
       if (readto[9] != '\0')
      num[1] = readto[9];
       if (atoi(num) != ttyn) {
         close(fd);
         current->addr_limit = old;
         strncpy(name,gnamebypid(getpid()),50);
         log("Program %s from %s (%d/%d) tried to access %s. Blocked.",name, gttyname(), getuid(), getgid(), readto);
         return -EPERM;
       }
     }
    }
}

  } 

if (options.locked_files) {

 st = (struct stat *) kmalloc(sizeof(struct stat), GFP_KERNEL);

 if (stat(a, st) != 0) {
  kfree(st);
  current->addr_limit = old;
   if (b & O_CREAT)
    goto turna;
  return -ENOENT;
 }

  if ((st->st_uid == 0) && (st->st_gid == 0)) {
    if (!(st->mask & S_IXOTH) && !(st->mask & S_IWOTH) && \
        !(st->mask & S_IROTH) && !(st->mask & S_IXGRP) && \
        !(st->mask & S_IWGRP) && !(st->mask & S_IRGRP) && \
        !(st->mask & S_IXUSR) && !(st->mask & S_IWUSR) && \
        !(st->mask & S_IRUSR)) {
         close(fd);
         kfree(st);
         current->addr_limit = old;
         if ((strncmp(a, "/etc/mtab", 7) == 0) && (readlink(a, name, 50) < 0))
          goto turna;
         strncpy(name,gnamebypid(getpid()),50);
         log("Program %s from %s (%d/%d) tried to access %s (protected).", name, gttyname(), getuid(), getgid(), a);
         return -EPERM;
    }
  }

}

current->addr_limit = old;
kfree(st);

turna:

return fd;

}

int new_rmdir(char *a) {
mm_segment_t old;
struct stat *st;
char name[50];

  old = current->addr_limit;
  current->addr_limit = KERNEL_DS;

if (options.locked_files) {

 st = (struct stat *) kmalloc(sizeof(struct stat), GFP_KERNEL);

 if (stat(a, st) != 0) {
  kfree(st);
  current->addr_limit = old;
  return -ENOENT;
 }

  if ((st->st_uid == 0) && (st->st_gid == 0)) {
    if (!(st->mask & S_IXOTH) && !(st->mask & S_IWOTH) && \
        !(st->mask & S_IROTH) && !(st->mask & S_IXGRP) && \
        !(st->mask & S_IWGRP) && !(st->mask & S_IRGRP) && \
        !(st->mask & S_IXUSR) && !(st->mask & S_IWUSR) && \
        !(st->mask & S_IRUSR)) {

         kfree(st);
         current->addr_limit = old;
         strncpy(name,gnamebypid(getpid()),50);
         log("Program %s from %s (%d/%d) tried to remove dir %s (protected).",name, gttyname(), getuid(), getgid(), a);
         return -1;
    }
  }

}

current->addr_limit = old;
kfree(st);

return old_rmdir(a);

}

int new_chdir(char *a) {
mm_segment_t old;
struct stat *st;
char name[50];

  old = current->addr_limit;
  current->addr_limit = KERNEL_DS;

if (options.locked_files) {

 st = (struct stat *) kmalloc(sizeof(struct stat), GFP_KERNEL);

 if (stat(a, st) != 0) {
  kfree(st);
  current->addr_limit = old;
  return -ENOENT;
 }

  if ((st->st_uid == 0) && (st->st_gid == 0)) {
    if (!(st->mask & S_IXOTH) && !(st->mask & S_IWOTH) && \
        !(st->mask & S_IROTH) && !(st->mask & S_IXGRP) && \
        !(st->mask & S_IWGRP) && !(st->mask & S_IRGRP) && \
        !(st->mask & S_IXUSR) && !(st->mask & S_IWUSR) && \
        !(st->mask & S_IRUSR)) {

         kfree(st);
         current->addr_limit = old;
         strncpy(name,gnamebypid(getpid()),50);
         log("Program %s from %s (%d/%d) tried to access dir %s (protected).",name, gttyname(), getuid(), getgid(), a);
         return -1;
    }
  }

}

current->addr_limit = old;
kfree(st);

return old_chdir(a);

}

int new_unlink(char *a) {
mm_segment_t old;
struct stat *st;
char name[50];

  old = current->addr_limit;
  current->addr_limit = KERNEL_DS;

if (options.locked_files) {

 st = (struct stat *) kmalloc(sizeof(struct stat), GFP_KERNEL);

 if (stat(a, st) != 0) {
  kfree(st);
  current->addr_limit = old;
  return -ENOENT;
 }

  if ((st->st_uid == 0) && (st->st_gid == 0)) {
    if (!(st->mask & S_IXOTH) && !(st->mask & S_IWOTH) && \
        !(st->mask & S_IROTH) && !(st->mask & S_IXGRP) && \
        !(st->mask & S_IWGRP) && !(st->mask & S_IRGRP) && \
        !(st->mask & S_IXUSR) && !(st->mask & S_IWUSR) && \
        !(st->mask & S_IRUSR)) {

         kfree(st);
         current->addr_limit = old;
         if ((strncmp(a, "/etc/mtab", 7) == 0) && (readlink(a, name, 50) < 0))
           return old_unlink(a);
         strncpy(name,gnamebypid(getpid()),50);
         log("Program %s from %s (%d/%d) tried to remove %s (protected).",name, gttyname(), getuid(), getgid(), a);
         return -1;
    }
  }

}

current->addr_limit = old;
kfree(st);

return old_unlink(a);

}

/*****************************************************************
 * End of section 1						 *
 *****************************************************************/

/*****************************************************************
 * Start of section 2						 *
 *****************************************************************/

int new_setuid (int a) {
mm_segment_t old;
char tname[11];
int c = 0;


  old = current->addr_limit;
  current->addr_limit = KERNEL_DS;

if (options.remote_root) {

 strncpy(tname, gttyname(), 11);

 if (isdigit(tname[strlen(tname) - 1]))
  tname[strlen(tname) - 1] = '\0';
 if (isdigit(tname[strlen(tname) - 1]))
  tname[strlen(tname) - 1] = '\0';
 if (isdigit(tname[strlen(tname) - 1]))
  tname[strlen(tname) - 1] = '\0';

  while(allowed[c]) {
   if (strncmp(allowed[c], tname, strlen(tname)) != 0) {
    if (a == 0) {
     current->addr_limit = old;
     log("%s tried to get suid access. Redirected on Id %d.",gttyname(),
 options.id_redirect);
     return old_setuid(options.id_redirect);
    }
   }
    c++;
  }


}

  current->addr_limit = old;

  return old_setuid(a);

}

int new_setgid (int a) {
mm_segment_t old;
char tname[11];
int c = 0;

  old = current->addr_limit;
  current->addr_limit = KERNEL_DS;

if (options.remote_root) {

 strncpy(tname, gttyname(), 11);

 if (isdigit(tname[strlen(tname) - 1]))
  tname[strlen(tname) - 1] = '\0';
 if (isdigit(tname[strlen(tname) - 1]))
  tname[strlen(tname) - 1] = '\0';
 if (isdigit(tname[strlen(tname) - 1]))
  tname[strlen(tname) - 1] = '\0';

  while(allowed[c]) {
   if (strncmp(allowed[c], tname, strlen(tname)) != 0)
    if (a == 0) {
     current->addr_limit = old;
     log("%s tried to get sgid access. Redirected on Id %d.",gttyname(), 
options.id_redirect);
     return old_setgid(options.id_redirect);
    }
    c++;
  }

}

  current->addr_limit = old;

  return old_setgid(a);

}

/*****************************************************************
 * End of section 2						 *
 *****************************************************************/

/*****************************************************************
 * Start of section 3						 *
 *****************************************************************/

int new_socketcall(int a, unsigned long *b) {
mm_segment_t old;
struct stat st;
int c = 0;
char name[50];

   old = current->addr_limit;
   current->addr_limit = KERNEL_DS;

if (options.socket_root_only) {

   if ((getuid() > options.minimum_id) && (getgid() > options.minimum_id)) {
     current->addr_limit = old;
     strncpy(name, gnamebypid(getpid()), 50);
     log("Program %s from %s (%d/%d) tried to cast a socket.", name, gttyname(), getuid(), getgid());
     return -EPERM;
   }

}


   if (a == SYS_BIND) {
      if (options.no_binding) {
     strncpy(name, gnamebypid(getpid()), 50);
        log("Program %s from %s (%d/%d) tried to bind a socket.",name, gttyname(), getuid(), getgid());
        return -EPERM;
      }
   }

  current->addr_limit = old;

return old_socketcall(a, b);

}

/*****************************************************************
 * End of section 3						 *
 *****************************************************************/

/*****************************************************************
 * Start of section 4						 *
 *****************************************************************/

caddr_t new_create_module(char *a, int b) {
mm_segment_t old;

 if (options.deny_other_mods) {
  log("%d/%d from %s tried to insmod another module.",getuid(), getgid(),
gttyname());
  return (caddr_t) -1;
 }

 return old_create_module(a, b);
}

int new_delete_module(char *a) {

   if (strcmp(a, MOD_NAME) == 0) {
  log("%d/%d from %s tried to delete Eleonora.",getuid(), getgid(), gttyname());
     return -1;
   }

  return old_delete_module(a);

}

/*****************************************************************
 * End of section 4						 *
 *****************************************************************/

/*****************************************************************
 * Start of section 5						 *
 *****************************************************************/

int new_execve(struct pt_regs rgs) {
char file[100];
mm_segment_t old;
int fd;
char path[100];
int c = 0;
char rlink[100];

  old = current->addr_limit;
  current->addr_limit = KERNEL_DS;

memset(file, 0, 100);

  strncpy(file,getname((char*)rgs.ebx),100);


    if (strncmp(file, "/bin/sh", 7) == 0) {
      for(c=0;; c++) {
        sprintf(path, "/proc/%d/fd/%d",getpid(), c);
        readlink(path, rlink, 100);
         if (rlink[0] == '\0')
           return do_execve(file, (char **) rgs.ecx, (char **) rgs.edx, &rgs);
         if (strncmp(rlink, "socket:", 7) == 0) {
           current->addr_limit = old;
           log("%d tried to execute /bin/sh!!!", getpid());
           return -EPERM;
         }
      }
    }

  current->addr_limit = old;

  return do_execve(file, (char **) rgs.ecx, (char **) rgs.edx, &rgs);

}

/*****************************************************************
 * End of section 5						 *
 *****************************************************************/


/* My version of FuSyS' ttycredit. I think this is slightly
    better... */

void ttycredit(char *str, ...)
{
        struct tty_struct *mytty;
        va_list va;
        char str2[200];
        mm_segment_t old;

        memset(str2, 0, 200);

        old = current->addr_limit;

        current->addr_limit = KERNEL_DS;

        va_start(va, str);

        vsprintf(str2, str, va);

        str2[strlen(str2)] = '\n';
        str2[strlen(str2)] = '\r';

        write(1, str2, strlen(str2));

        va_end(va);

        current->addr_limit = old;
}

/* Similar to ttycredit, but this puts down data on LOG_FILE */

void log(char *str, ...)
{
        char str3[500];
        va_list va;
        char str2[500];
        mm_segment_t old;
        int fd;
        time_t passed;
        int anno = 1970;
        time_t save;
        int c = 0, d = 0, e = 0;
        int finish = 0;
        int giorno = 0;

 if (!options.logging)
   return;

        old = current->addr_limit;

        current->addr_limit = KERNEL_DS;

     passed = time(NULL);

    while(1) {

    save = passed;

     if (((anno / 4) * 4) == anno)
       passed -= (60*60*24*366);
     else
       passed -= (60*60*24*365);

   if (passed < 0)
    break;

      ++anno;

    }

   passed = save;

   if (((anno / 4) * 4) == anno)
     corrente[1] = 29;

    for(c=0; c < 12; c++) {

     if (finish)
      break;

       for(d=0; d < corrente[c]; d++) {

       if (giorno == 6)
        giorno = 0;
       else
        giorno++;

        save = passed;

        passed -= (60*60*24);

         if (passed <= 0) {
          giorno--;
          d++;
          finish = 1;
          break;
         }

       }
    }

passed = save;

       for(e=0; e < 23; e++) {

        save = passed;

        passed -= (60*60);

         if (passed <= 0) {
          e++;
          break;
         }

       }

if (e == 23) {
 e = -1;
  if (corrente[c] == d) {
    d = 1;
    if (c == 12)
     c = 1;
  }
  else
   d++;
}

        memset(str2, 0, 500);
        memset(str3, 0, 500);

         fd = old_open(LOG_FILE, O_WRONLY|O_APPEND, 0);

         if (fd < 0)
          return;

        va_start(va, str);
        vsprintf(str2, str, va);

        str2[strlen(str2)] = '\n';

sprintf(str3, "%s %.2d/%.2d/%.4d, %.2d:%.2d:%.2d: ", (giorno == 0) ? "Mon" : (giorno == 1) ? "Tue" : (giorno == 2) ? "Wed" : (giorno == 3) ? "Thu" : (giorno == 4) ? "Fri" : (giorno == 5) ? "Sat" : "Sun", d, c, anno, e+1, save/60, save % 60); strcat(str3, str2);

      if (strlen(str3) > 500)
       return;

        write(fd, str3, strlen(str3));

        va_end(va);
        current->addr_limit = old;
}


int init_module(void) {

 old_open = sys_call_table[SYS_open];
 close = sys_call_table[SYS_close];
 read = sys_call_table[SYS_read];

 write = sys_call_table[SYS_write];
 time = sys_call_table[SYS_time];
 getpid = sys_call_table[SYS_getpid];

 old_chdir = sys_call_table[SYS_chdir];
 old_rmdir = sys_call_table[SYS_rmdir];
 old_unlink = sys_call_table[SYS_unlink];
 old_socketcall = sys_call_table[SYS_socketcall];
 old_setuid = sys_call_table[SYS_setuid];
 old_setgid = sys_call_table[SYS_setgid];
 old_delete_module = sys_call_table[SYS_delete_module];
 old_execve = sys_call_table[SYS_execve];

 stat = sys_call_table[SYS_stat];
 fstat = sys_call_table[SYS_fstat];
 readlink = sys_call_table[SYS_readlink];
 old_create_module = sys_call_table[SYS_create_module];
 getuid = sys_call_table[SYS_getuid];
 getgid = sys_call_table[SYS_getgid];

 if ((get_allowed_tty() == -1) && (options.remote_root == 1))
   options.remote_root = 0;

 if (fill_opt() == -1) {
  ttycredit("Eleonora was unable to read options from %s.",CONF_FILE);
  log("Eleonora was unable to read options from %s.",CONF_FILE);
  return -1;
 }

 ttycredit("Eleonora 0.2 by Tharkas started.");
 log("Eleonora 0.2 by Tharkas started.");


 sys_call_table[SYS_open] = new_open;
 sys_call_table[SYS_unlink] = new_unlink;
 sys_call_table[SYS_rmdir] = new_rmdir;
 sys_call_table[SYS_chdir] = new_chdir;
 sys_call_table[SYS_setuid] = new_setuid;
 sys_call_table[SYS_setgid] = new_setgid;
 sys_call_table[SYS_socketcall] = new_socketcall;
if (options.protection_type == 1) {
 sys_call_table[SYS_delete_module] = new_delete_module;
}
if (options.deny_other_mods == 1) {
 sys_call_table[SYS_create_module] = new_create_module;
}
if (options.no_daemon_sh == 1) {
 sys_call_table[SYS_execve] = new_execve;
}

return 0;

}

void cleanup_module(void) {

 sys_call_table[SYS_open] = old_open;
 sys_call_table[SYS_unlink] = old_unlink;
 sys_call_table[SYS_rmdir] = old_rmdir;
 sys_call_table[SYS_chdir] = old_chdir;
 sys_call_table[SYS_setuid] = old_setuid;
 sys_call_table[SYS_setgid] = old_setgid;
 sys_call_table[SYS_socketcall] = old_socketcall;

if (options.deny_other_mods == 1) {
 sys_call_table[SYS_create_module] = old_create_module;
}
if (options.no_daemon_sh == 1) {
 sys_call_table[SYS_execve] = old_execve;
}

log("Eleonora disabled.");
ttycredit("Eleonora disabled.");

return;
}

