#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <ctype.h>

#define BANNER printf("\tEleonora configuration main menu\n")


struct ele_opt {

	short locked_files;
	short deny_vcss;
	short deny_ttys;
	short remote_root;
	short socket_root_only;
	short no_binding;
        short protection_type;
        short no_daemon_sh;
        short logging;
        short deny_other_mods;
        unsigned int minimum_id;
        unsigned int id_redirect;


};

int make_default (struct ele_opt *opt) {

  opt->locked_files = 1;
  opt->protection_type = 0;
  opt->no_binding = 0;
  opt->minimum_id = 0;
  opt->socket_root_only = 1;
  opt->remote_root = 0;
  opt->deny_ttys = 0;
  opt->deny_vcss = 1;
  opt->no_daemon_sh = 1;
  opt->id_redirect = 99;
  opt->logging = 1;
  opt->deny_other_mods = 0;

}

char *onoff (int a) {
  if (a == 1)
   return "ON";
  if (a == 0)
   return "OFF";
  else
   return "NULL";
}

main() {
int fd;
int state = 0;
struct ele_opt options;
int res;
int selection;

 fd = open("/etc/Eleonora/ele.conf", O_RDONLY);

  if (fd == -1) {
     perror("open");
     state = 1;       
     make_default(&options);
  }


  if (state == 0) {
   res = read(fd, &options, sizeof(struct ele_opt));
  perror("read");
   printf("%d\t%d\n",res, fd);
   if (res < sizeof(struct ele_opt)) {
     system ("rm -rf /etc/Eleonora/ele.conf");
     exit(-1);
   } 
   close(fd);
  }


start:

   system("clear");
   BANNER;
   printf("\n\nPlease select one of the options listed below.\n");
   printf("\t\t   Option\t\t\tActual value\n");

   printf("\n\n\t\t1.  Locked Files\t\t\t%s\n", onoff(options.locked_files));
   printf("\t\t2.  Deny vcs access\t\t\t%s\n", onoff(options.deny_vcss));
   printf("\t\t3.  Deny tty access\t\t\t%s\n", onoff(options.deny_ttys));
   printf("\t\t4.  Deny remote root access\t\t%s\n",onoff(options.remote_root));
   printf("\t\t5.  Redirected id (opt 4)\t\t%d\n",options.id_redirect);
   printf("\t\t6.  Restricted socket use.\t\t%s\n",onoff(options.socket_root_only));
   printf("\t\t7.  Minimum ID for opt 6.\t\t%d\n",options.minimum_id);
   printf("\t\t8.  Noone can bind a server.\t\t%s\n",onoff(options.no_binding));
   printf("\t\t9.  Daemons can't cast shells\t\t%s\n",onoff(options.no_daemon_sh));
   printf("\t\t10. Actual security level:\t\t%s\n",(options.protection_type == 0) ? "NOT SECURE" : "SECURE");
   printf("\t\t11. Logging\t\t\t\t%s\n",onoff(options.logging));
   printf("\t\t12. Deny insmod access\t\t\t%s\n",onoff(options.deny_other_mods));
   printf("\n\t\t13. Save data on Eleonora config file.\n");
   printf("\t\t14. Exit without saving.\n");
   printf("\n\t\t15. Load defaults.\n");

   printf("\n\tPlease select an option: ");
   selection = 0;
   scanf("%d", &selection);
 if (selection == 10)
   printf("\t0 is NOT SECURE, 1 is SECURE.\n");
 else if ((selection != 13) && (selection != 14) && (selection != 7) && (selection != 5))
   printf("\t0 is OFF, 1 is ON.\n");

      switch (selection) {
         case 1:
           printf("Actual value: %d\tInsert new value: ", options.locked_files);
           selection = 0;
           scanf("%d", &selection);
         if ((selection != 1) && (selection != 0))
           goto start;
           options.locked_files = selection;
           goto start;
           break;
         case 2:
           printf("Actual value: %d\tInsert new value: ", options.deny_vcss);
           selection = 0;
           scanf("%d", &selection);
           printf("Selection: %d\n",selection);

         if ((selection != 1) && (selection != 0))
           goto start;
           options.deny_vcss = selection;
           goto start;
           break;
         case 3:
           printf("Actual value: %d\tInsert new value: ", options.deny_ttys);
           scanf("%d", &selection);
         if ((selection != 1) && (selection != 0))
           goto start;
           options.deny_ttys = selection;
           goto start;
           break;
         case 4:
           printf("Actual value: %d\tInsert new value: ", options.remote_root);
           scanf("%d", &selection);
         if ((selection != 1) && (selection != 0))
           goto start;
           options.remote_root = selection;
           goto start;
           break;
         case 5:
           printf("This sets the Id where dangerous users will be redirected. (opt 4)\n");
           printf("Actual value: %d\tInsert new value: ", options.id_redirect);
           scanf("%d", &selection);
           options.id_redirect = selection;
           goto start;
           break;
         case 6:
           printf("Actual value: %d\tInsert new value: ", options.socket_root_only);
           scanf("%d", &selection);
         if ((selection != 1) && (selection != 0))
           goto start;
           options.socket_root_only = selection;
           goto start;
           break;
         case 7:
           printf("This sets the minimum Id for using sockets (opt 6)\n");
           printf("Actual value: %d\tInsert new value: ", options.minimum_id);
           scanf("%d", &selection);
           options.minimum_id = selection;
           goto start;
           break;
         case 8:
           printf("Actual value: %d\tInsert new value: ", options.no_binding);
           scanf("%d", &selection);
         if ((selection != 1) && (selection != 0))
           goto start;
           options.no_binding = selection;
           goto start;
           break;
         case 9:
           printf("Actual value: %d\tInsert new value: ", options.no_daemon_sh);
           scanf("%d", &selection);
         if ((selection != 1) && (selection != 0))
           goto start;
           options.no_daemon_sh = selection;
           goto start;
           break;
         case 10:
           printf("Actual value: %d\tInsert new value: ", options.protection_type);
           scanf("%d", &selection);
         if ((selection != 1) && (selection != 0))
           goto start;
           options.protection_type = selection;
           goto start;
           break;
         case 11:
           printf("Actual value: %d\tInsert new value: ", options.logging);
           scanf("%d", &selection);
         if ((selection != 1) && (selection != 0))
           goto start;
           options.logging = selection;
           goto start;
           break;
         case 12:
           printf("Actual value: %d\tInsert new value: ", options.deny_other_mods);
           scanf("%d", &selection);
         if ((selection != 1) && (selection != 0))
           goto start;
           options.deny_other_mods = selection;
           goto start;
           break;
         case 13:
          if (state == 1)
           fd = open("/etc/Eleonora/ele.conf", O_WRONLY|O_CREAT, 0600);
            else
           fd = open("/etc/Eleonora/ele.conf", O_WRONLY|O_TRUNC);
           res = write(fd, &options, sizeof(struct ele_opt));
           printf("Exiting. %d bytes written down.\n",res);
           exit(1);
           break;
         case 14:
           printf("Thank you for using Eleonora.\n");
           exit(0);   
           break;
         case 15:
           make_default(&options);
           goto start;
         default:
           printf("An error occurred while configuring Eleonora.\n");
           printf("Retry, you'll be luckier.\n");
           exit(0);
           break;
      }

}
