/*
 *  Name: hdrsnf.c  [SNiFf]
 *  Date: Mon Aug 12 13:13:34 2001
 *  Author: uLiX [uLiX@gmx.it]
 *
 *  thnx to all my friends... That's all folk: No More Is Ash...
 *
 *  Tested on: DEBiAN GNU/LiNUX (Woody) kernel 2.4.5 on a i586
 */

#include <signal.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <ctype.h>
#include <time.h>

#include <sys/socket.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/un.h>

#include <netinet/ip.h>
#include <netinet/ip_icmp.h>

#include <netinet/ip6.h>
#include <netinet/icmp6.h>

#include <netinet/in.h>
#include <netinet/igmp.h>
#include <netinet/tcp.h>
#include <netinet/udp.h>

#include <netdb.h>
#include <arpa/inet.h>

#include "../libpcap-0.4/pcap.h"

#define  B_SIZE    4*1024
#define  MAX_SIZE  8*1024

#define DIRE	  "./log/"
										

extern  char  *optarg;
extern  int   optind;

/*** mainsnf.c ***/
void    usage           ();

/*** pcksnf.c ***/
int     sniffo          (int, int, int, int, int, int);
void	ippg_show		(int, int, int, int, int, int);
void 	ipng_show		(int, int, int, int, int, int);
void 	ippg_ops_show 	(u_char *, int, FILE *);

/*** printsnf.c ***/
void    data_sniffo     (char *, u_int, FILE *);
void    print_ascii_hex (char *, u_int, FILE *);

/*** icmpsnf.c ***/
void    icmp_show       (int, int, int, int, int);

/*** icmpv6snf.c ***/
void    icmpvsei_show   (int, int, int, int, int);

/*** igmpsnf.c ***/
void    igmp_show       (int, int, int);

/*** tcpsnf.c ***/
void    tcp_show        (int, int, int, int, int);
//void 	tcp_ops_show 	(u_char *, int, FILE *); /*** time out ***/

/*** tcpv6snf.c ***/
void    tcpvsei_show    (int, int, int, int, int);

/*** udpsnf.c ***/
void    udp_show        (int, int, int, int, int);

/*** udpv6snf.c ***/
void    udpvsei_show    (int, int, int, int, int);

/*** utlssnf.c ***/
void    pcap_device_on	(int, int, int, int, int, int, int);
void    pcap_device_off ();
char 	*resolve_port_src	(u_int);
char 	*resolve_port_dst	(u_int);
char 	*resolve_src 	(char *);
char    *resolve_dst    (char *);

/*** opsseisnf.c ***/
void	hop_show		(const u_char *, int);
void  	dst_show        (const u_char *, int);
void    frag_show       (const u_char *, int);
void    route_show      (const u_char *, int, int);
void    nope_show       (const u_char *, int);
//void	encap_show 		(const u_char *, int)

/*** variabili globali ***/
char	*p_name;
char 	name[256];
const 	u_char	*info_buf;
char    *name_face;
char    *data_info;
time_t	tmp;
char    datora[60];
FILE    *log;			/*** fd per loggare su file... ***/
u_short offset;			/*** pcap ***/
