/*
 *  Name: icmpsnf.c  [SNiFf]
 *  Date: Mon Aug 12 13:14:43 2001
 *  Author: uLiX [uLiX@gmx.it]
 *
 *  thnx to all my friends... That's all folk: No More Is Ash...
 *
 *  Tested on: DEBiAN GNU/LiNUX (Woody) kernel 2.4.5 on a i586
 */

#include "hdrsnf.h"
#include "icmpsnf.h"
#include "utlssnf.h"

void icmp_show (int v, int d, int x, int dUMP, int h)
{
	tmp = time(NULL);
	strftime(datora, 60, "%T"/*[%D]"*/, localtime(&tmp));
/*** questa %T stampa il tempo al completo... aggiunta con C99 ***/
		
	icmp = (struct icmp *)(info_buf + sizeof(struct ip) + offset);
	ip   = (struct ip *)(info_buf + offset);
	
	data_info = NULL;	
	data_info = (char *)(info_buf + sizeof(struct ip) 
								+ sizeof(struct icmp) + offset);	

	hlen    = HDRLEN;
	len	    = ntohs(ip->ip_len);
	tos     = ip->ip_tos;
	id      = ip->ip_id;
	frag    = ntohs(ip->ip_off);
	ttl     = ip->ip_ttl;
	
	saddr_ipv4 = (unsigned char *)inet_ntop(AF_INET, &ip->ip_src.s_addr,
												src_ipv4, sizeof(src_ipv4));
	daddr_ipv4 = (unsigned char *)inet_ntop(AF_INET, &ip->ip_dst.s_addr,
												dst_ipv4, sizeof(dst_ipv4));
	
	if (dUMP) {

    	snprintf (name, sizeof(name), "%siCMP.lOg", DIRE);
    	log = fopen (name, "a");

		if (!h)
			fprintf(log, "\n\n[IPv4] %s  fROM: %s >> tO: %s\n   ",
							datora, saddr_ipv4, daddr_ipv4);
		if (h)
			fprintf(log, "\n\n[IPv4] %s %s >> %s\n   ",
					datora, resolve_src(src_ipv4), resolve_dst(dst_ipv4));
		fprintf(log, "    lENGTH: %d  tOS: 0x%X  iD: %d  tTL: %d  ",
										                 len, tos, id, ttl);
    	if (v) {
			if (frag & IP_RF)
				fprintf(log, "fRAG: RF (0x%x)  ", frag);
			else if (frag & IP_DF)
				fprintf(log, "fRAG: DF (0x%x)  ", frag);
			else if (frag & IP_MF)
				fprintf(log, "fRAG: MF (0x%x)  ", frag);
			else fprintf(log, "fRAG: 0x%x  ", frag);
		}
		//else fprintf(log, "\n");    /*** new line per tcp ***/

		if ((hlen -= sizeof(struct ip)) > 0) {
			fprintf(log, "OPtlEN: %d  ", hlen);
			ippg_ops_show((u_char *)ip, hlen, log);
			}
		else fprintf(log, "\n");
		
     	fprintf(log, "[iCMP] tYPE:  ");
		
      	switch (icmp->icmp_type) {
      		case 0:
					fprintf(log, "ECHO REPLY  ");
        			break;
      		case 3:
					fprintf(log, "DEST UNREACHABLE: ");
					switch (icmp->icmp_code) {
							case 0:
									fprintf(log, "NetWORk UNREAChABlE  ");
									break;
							case 1:
									fprintf(log, "hOST UNREAChABlE  ");
									break;
							case 2:
									fprintf(log, "pROTOCOl UNREAChABlE  ");
									break;
							case 3:
									fprintf(log, "pORT UNREAChABlE  ");
									break;
							case 4:
									fprintf(log, "fRAGMENTATION NEDEEd (DF)  ");
									break;
							case 5:
									fprintf(log, "sOURCE ROUtE fAIlED  ");
									break;
							case 6:
									fprintf(log, "dEST NetWORk UNkNOWN  ");
									break;
							case 7:
									fprintf(log, "dEST hOST UNkNOWN  ");
									break;
							case 8:
									fprintf(log, "sOURCE hOST iSOLAtED  ");
									break;
							case 9:
									fprintf(log, "dEST NetWORk AdMINISTRAtIVElY pROhIBITEd  ");
									break;
							case 10:
									fprintf(log, "dEST hOST AdMINISTRAtIVElY pROhIBITEd  ");
									break;
							case 11:
									fprintf(log, "NetWORk UNREAChABlE (tOS)  ");
									break;
							case 12:
									fprintf(log, "hOST UNREAChABlE (tOS)  ");
									break;
							case 13:
									fprintf(log, "cOMMUNiCAtiON AdMINISTRAtIVElY pROhIBITEd  ");
									break;
							case 14:
									fprintf(log, "hOST pRECEDENCE ViOLATiON  ");
									break;
							case 15:
									fprintf(log, "pRECEDENCE CUTOff iN EFFECt  ");
									break;
					}				
					break;
			case 4:
					fprintf(log, "SOURCE QUENCH  ");
					break;
      		case 5:
					fprintf(log, "REDIRECT: ");
					switch(icmp->icmp_code) {
							case 0:
									fprintf(log, "REDIRECT fOR NetWORk  ");
									break;
							case 1:
									fprintf(log, "REDIRECT fOR hOST  ");
									break;\
							case 2:
									fprintf(log, "REDIRECT fOR tOS & NetWORk  ");
									break;
							case 3:
									fprintf(log, "REDIRECT fOR tOS & hOST  ");
									break;
					}
					break;
      		case 8:
					fprintf(log, "ECHO REQUESt  ");
					break;
			case 9:
					fprintf(log, "ROUtER AdVERTiSEMENt  ");
					break;
			case 10:
					fprintf(log, "ROUtER SOLiCitATiON  ");
					break;
      		case 11:
					fprintf(log, "TIME EXCEEDED: ");
					switch (icmp->icmp_code) {
							case 0:
									fprintf(log, "tTL (0) dURiNG tRANSit  ");
									break;
						 	case 1:
									fprintf(log, "tTL (0) dURiNG REASSEMBlY  ");
									break;
					}
					break;
      		case 12:
					fprintf(log, "PARAMEtER PROBlEM: ");
					switch (icmp->icmp_code) {
							case 0:
									fprintf(log, "iP hEADER bAD  ");
									break;
							case 1:
									fprintf(log, "REQUiREd OPtiON MiSSiNG  ");
									break;
					}
					break;
      		case 13:
					fprintf(log, "TIMESTAMP REQUESt  ");
					break;
      		case 14:
        			fprintf(log, "TIMESTAMP REPLY  ");
        			break;
      		case 15:
        			fprintf(log, "INFORMAtiON REQUESt  ");
       		 		break;
      		case 16:
        			fprintf(log, "INFORMAtiON REPLY  ");
        			break;
      		case 17:
        			fprintf(log, "ADDRESS MASk REQUESt  ");
        			break;
      		case 18:
        			fprintf(log, "ADDRESS MASk REPLY  ");
        			break;
      		default:
	 				fprintf(log, "UNkNOWN (%d)  ", icmp->icmp_type);
	 				break;
      	}
      	if (v) {
			if (icmp->icmp_type ==  3 || icmp->icmp_type ==  5 ||
							icmp->icmp_type ==  11)
				fprintf(log, "\n       ");
      		fprintf(log, "<cODE: 0x%x ", icmp->icmp_code);
      		fprintf(log, "sEq: 0x%x ", icmp->icmp_seq);
			fprintf(log, "iD: 0x%x ", icmp->icmp_id);
      		fprintf(log, "Ck_SUM 0x%x>\n", icmp->icmp_cksum);
		}
		else fprintf(log, "\n");
      
      	if(d)
			data_sniffo(data_info, ICMP_HDR_LEN, log);
		if (x)
	  		print_ascii_hex(data_info, ICMP_HDR_LEN, log);

		fclose (log);
	}
		
	if (!dUMP) {

		if (!h)
			fprintf(stdout, "\n\n[IPv4] %s  fROM: %s >> tO: %s\n   ",
							datora, saddr_ipv4, daddr_ipv4);
		if (h)
			fprintf(stdout, "\n\n[IPv4] %s %s >> %s\n   ",
					datora, resolve_src(src_ipv4), resolve_dst(dst_ipv4));
			fprintf(stdout, "    lENGTH: %d  tOS: 0x%X  iD: %d  tTL: %d  ",
										                	len, tos, id, ttl);
		if (v) {
			if (frag & IP_RF)
				fprintf(stdout, "fRAG: RF (0x%x)  ", frag);
			else if (frag & IP_DF)
				fprintf(stdout, "fRAG: DF (0x%x)  ", frag);
			else if (frag & IP_MF)
				fprintf(stdout, "fRAG: MF (0x%x)  ", frag);
			else fprintf(stdout, "fRAG: 0x%x  ", frag);
		}
		//else fprintf(stdout, "\n");    /*** new line per tcp ***/

		if ((hlen -= sizeof(struct ip)) > 0) {
			fprintf(stdout, "OPtlEN: %d  ", hlen);
			ippg_ops_show((u_char *)ip, hlen, stdout);
		}
		else fprintf(stdout, "\n");
			
     	fprintf(stdout, "[iCMP] tYPE:  ");
		
      	switch (icmp->icmp_type) {
      		case 0:
					fprintf(stdout, "ECHO REPLY  ");
        			break;
      		case 3:
					fprintf(stdout, "DEST UNREACHABLE: ");
					switch (icmp->icmp_code) {
							case 0:
									fprintf(stdout, "NetWORk UNREAChABlE  ");
									break;
							case 1:
									fprintf(stdout, "hOST UNREAChABlE  ");
									break;
							case 2:
									fprintf(stdout, "pROTOCOl UNREAChABlE  ");
									break;
							case 3:
									fprintf(stdout, "pORT UNREAChABlE  ");
									break;
							case 4:
									fprintf(stdout, "fRAGMENTATION NEDEEd (DF)  ");
									break;
							case 5:
									fprintf(stdout, "sOURCE ROUtE fAIlED  ");
									break;
							case 6:
									fprintf(stdout, "dEST NetWORk UNkNOWN  ");
									break;
							case 7:
									fprintf(stdout, "dEST hOST UNkNOWN  ");
									break;
							case 8:
									fprintf(stdout, "sOURCE hOST iSOLAtED  ");
									break;
							case 9:
									fprintf(stdout, "dEST NetWORk AdMINISTRAtIVElY pROhIBITEd  ");
									break;
							case 10:
									fprintf(stdout, "dEST hOST AdMINISTRAtIVElY pROhIBITEd  ");
									break;
							case 11:
									fprintf(stdout, "NetWORk UNREAChABlE (tOS)  ");
									break;
							case 12:
									fprintf(stdout, "hOST UNREAChABlE (tOS)  ");
									break;
							case 13:
									fprintf(stdout, "cOMMUNiCAtiON AdMINISTRAtIVElY pROhIBITEd  ");
									break;
							case 14:
									fprintf(stdout, "hOST pRECEDENCE ViOLATiON  ");
									break;
							case 15:
									fprintf(stdout, "pRECEDENCE CUTOff iN EFFECt  ");
									break;
					}				
					break;
			case 4:
					fprintf(stdout, "SOURCE QUENCH  ");
					break;
      		case 5:
					fprintf(stdout, "REDIRECT: ");
					switch(icmp->icmp_code) {
							case 0:
									fprintf(stdout, "REDIRECT fOR NetWORk  ");
									break;
							case 1:
									fprintf(stdout, "REDIRECT fOR hOST  ");
									break;
							case 2:
									fprintf(stdout, "REDIRECT fOR tOS & NetWORk  ");
									break;
							case 3:
									fprintf(stdout, "REDIRECT fOR tOS & hOST  ");
									break;
					}
					break;
      		case 8:
					fprintf(stdout, "ECHO REQUESt  ");
					break;
			case 9:
					fprintf(stdout, "ROUtER AdVERTiSEMENt  ");
					break;
			case 10:
					fprintf(stdout, "ROUtER SOLiCitATiON  ");
					break;
      		case 11:
					fprintf(stdout, "TIME EXCEEDED: ");
					switch (icmp->icmp_code) {
							case 0:
									fprintf(stdout, "tTL (0) dURiNG tRANSit  ");
									break;
						 	case 1:
									fprintf(stdout, "tTL (0) dURiNG REASSEMBlY  ");
									break;
					}
					break;
      		case 12:
					fprintf(stdout, "PARAMEtER PROBlEM: ");
					switch (icmp->icmp_code) {
							case 0:
									fprintf(stdout, "iP hEADER bAD  ");
									break;
							case 1:
									fprintf(stdout, "REQUiREd OPtiON MiSSiNG  ");
									break;
					}
					break;
      		case 13:
					fprintf(stdout, "TIMESTAMP REQUESt  ");
					break;
      		case 14:
        			fprintf(stdout, "TIMESTAMP REPLY  ");
        			break;
      		case 15:
        			fprintf(stdout, "INFORMAtiON REQUESt  ");
       		 		break;
      		case 16:
        			fprintf(stdout, "INFORMAtiON REPLY  ");
        			break;
      		case 17:
        			fprintf(stdout, "ADDRESS MASk REQUESt  ");
        			break;
      		case 18:
        			fprintf(stdout, "ADDRESS MASk REPLY  ");
        			break;
      		default:
	 				fprintf(stdout, "UNkNOWN (%d)  ", icmp->icmp_type);
	 				break;
      	}
      	if (v) {
			if (icmp->icmp_type == 	3 || icmp->icmp_type ==  5 || 
							icmp->icmp_type ==  11)
				fprintf(stdout, "\n       ");
      		fprintf(stdout, "<cODE: 0x%x ", icmp->icmp_code);
      		fprintf(stdout, "sEq: 0x%x ", icmp->icmp_seq);
			fprintf(stdout, "iD: 0x%x ", icmp->icmp_id);
      		fprintf(stdout, "Ck_SUM 0x%x>\n", icmp->icmp_cksum);
		}
		//else fprintf(stdout, "\n");
      
      	if(d)
			data_sniffo(data_info, ICMP_HDR_LEN, stdout);
		if (x)
	  		print_ascii_hex(data_info, ICMP_HDR_LEN, stdout);
	}
}
