/*
 *  Name: icmpv6snf.c  [SNiFf]
 *  Date: Mon Aug 12 13:15:00 2001
 *  Author: uLiX [uLiX@gmx.it]
 *
 *  thnx to all my friends... That's all folk: No More Is Ash...
 *
 *  Tested on: DEBiAN GNU/LiNUX (Woody) kernel 2.4.5 on a i586
 */

#include "hdrsnf.h"
#include "utlssnf.h"
#include "icmpv6snf.h"

void icmpvsei_show (int v, int d, int x, int dUMP, int h)
{
	tmp = time(NULL);
	strftime(datora, 60, "%T"/*[%D]"*/, localtime(&tmp));
/*** questa %T stampa il tempo al completo... aggiunta con C99 ***/
		
	icmp6 = (struct icmp6_hdr *)(info_buf + sizeof(struct ip6_hdr) + offset);
	ip6 = (struct ip6_hdr *)(info_buf + offset);	
	
	data_info = NULL;
	data_info = (char *)(info_buf + sizeof(struct ip6_hdr)
			  						+ sizeof(struct icmp6_hdr) + offset);

	prty    =   ntohs(ip6->ip6_vfc);
	flow    =   ntohl(ip6->ip6_flow);
	plen    =   ntohs(ip6->ip6_plen);
	hlim    =   ip6->ip6_hlim;

	saddr_ipv6 = (unsigned char *)inet_ntop(AF_INET6, &ip6->ip6_src,
									              src_ipv6, sizeof(src_ipv6));
	daddr_ipv6 = (unsigned char *)inet_ntop(AF_INET6, &ip6->ip6_dst,
										          dst_ipv6, sizeof(dst_ipv6));
	
  	if (dUMP) {

    	snprintf (name, sizeof (name), "%siCMPv6.lOg", DIRE);
    	log = fopen (name, "a"); 
    
		if (!h)
			fprintf(log, "\n\n[IPv6] %s  fROM: %s >> tO: %s\n   ",
							datora, saddr_ipv6, daddr_ipv6);
		if (h)
			fprintf(log, "\n\n[IPv6] %s %s >> %s\n   ",
					datora, resolve_src(src_ipv6), resolve_dst(dst_ipv6));
		fprintf(log, "    PRiORiTY: 0x%x  lENGTH: %d  HlIM: %d  ", 
														prty, plen, hlim);
	
		if (v) {
			if (flow & PRI)
				fprintf(log, "pRI: 0x%x\n", (flow & PRI) >> 24);
			else if (flow & FLOW1)
				fprintf(log, "fLOW: 0x%x\n", (flow & FLOW2));
			else if (flow & CLASS)
				fprintf(log, "CLAsS: 0x%x\n", (flow & CLASS) >> 20);
			else if (flow & FLOW2)
				fprintf(log, "fLOW: 0x%x\n", (flow & FLOW2));
			else fprintf(log, "fLOW: 0x%x\n", flow);
		}
		else fprintf(log, "\n");    /*** new line per icmp ***/
		
		fprintf(log, "[iCMP] (v6) tYPE:  ");
		
      	switch(icmp6->icmp6_type) {
				case 1:
						fprintf(log, "DST UNREAChABlE: ");
						switch (icmp6->icmp6_code) {
								case 0:
										fprintf(log, "nO ROUtE tO DST  ");
										break;
								case 1:
										fprintf(log, "AdMINISTRAtIVElY pROhIBITEd (FW)  ");
										break;
								case 2:
										fprintf(log, "NOT a NEiGHbOR  ");
										break;
								case 3:
										fprintf(log, "AddRESS UNREAChABlE  ");
										break;
								case 4:
										fprintf(log, "pORT UNREAChABlE  ");
										break;
						}
						break;
				case 2:
						fprintf(log, "pACkEt tOO BiG  ");
						break;
				case 3:
						fprintf(log, "TIME EXCEEDED: ");
						switch (icmp6->icmp6_code) {
								case 0:
										fprintf(log, "hOP LiMit EXCEEDED iN tRANSit  ");
										break;
								case 1:
										fprintf(log, "fRAGMENt REASSEMBlY tIME EXCEEDED  ");
										break;
						}
						break;
				case 4:
					 	fprintf(log, "PARAMEtER PROBlEM: ");
						switch (icmp6->icmp6_code) {
								case 0:
										fprintf(log, "ERRONEOUS hEADER fIElD  ");
										break;
								case 1:
										fprintf(log, "UNRECOGNiZED nEXt hEADER  ");
										break;
								case 2:
										fprintf(log, "UNRECOGNiZED OPtiON  ");
										break;
						}
						break;
				case 128:
						fprintf(log, "ECHO REQUESt  ");
						break;
				case 129:
						fprintf(log, "ECHO REPLY  ");
						break;
				case 130:
						fprintf(log, "gROUP MEMbERSHiP QUERY  ");
						break;
				case 131:
						fprintf(log, "gROUP MEMbERSHiP REPORt  ");
						break;
				case 132:
						fprintf(log, "gROUP MEMbERSHiP REDUCtiON  ");
						break;
				case 133:
						fprintf(log, "ROUtER SOLiCitATiON  ");
						break;
				case 134:
						fprintf(log, "ROUtER AdVERTiSEMENt  ");
						break;
				case 135:
						fprintf(log, "NEiGHbOR SOLiCitATiON  ");
						break;
				case 136:
						fprintf(log, "NEiGHbOR AdVERTiSEMENt  ");
						break;
				case 137:
						fprintf(log, "REDiRECt  ");
						break;
		}

		if (v) {
			//fprintf(log, "       ");
			fprintf(log, "<cODE: 0x%x ", icmp6->icmp6_code);
			fprintf(log, "sEq: 0x%x ", icmp6->icmp6_seq);
			fprintf(log, "iD: 0x%x ", icmp6->icmp6_id);
			fprintf(log, "Ck_SUM 0x%x>\n", icmp6->icmp6_cksum);
		}
		else fprintf(log, "\n");

		if(d)
			data_sniffo(data_info, ICMP6_HDR_LEN, log);
		if (x)
			print_ascii_hex(data_info, ICMP6_HDR_LEN, log);
		
		fclose (log);
		
	}
  
  	if (!dUMP) {

		if (!h)
			fprintf(stdout, "\n\n[IPv6] %s  fROM: %s >> tO: %s\n   ",
								datora, saddr_ipv6, daddr_ipv6);
		if (h)
			fprintf(stdout, "\n\n[IPv6] %s %s >> %s\n   ",
						datora, resolve_src(src_ipv6), resolve_dst(dst_ipv6));
		fprintf(stdout, "    PRiORiTY: 0x%x  lENGTH: %d  HlIM: %d  ",
													prty, plen, hlim);
		if (v) {
			if (flow & PRI)
				fprintf(stdout, "pRI: 0x%x\n", (flow & PRI) >> 24);
			else if (flow & FLOW1)
				fprintf(stdout, "fLOW: 0x%x\n", (flow & FLOW2));
			else if (flow & CLASS)
				fprintf(stdout, "CLAsS: 0x%x\n", (flow & CLASS) >> 20);
			else if (flow & FLOW2)
				fprintf(stdout, "fLOW: 0x%x\n", (flow & FLOW2));
			else fprintf(stdout, "fLOW: 0x%x\n", flow);
		}
		else fprintf(stdout, "\n");    /*** new line per icmp ***/
			
		fprintf(stdout, "[iCMP] (v6) tYPE:  ");
		
      	switch(icmp6->icmp6_type) {
				case 1:
						fprintf(stdout, "DST UNREAChABlE: ");
						switch (icmp6->icmp6_code) {
								case 0:
										fprintf(stdout, "nO ROUtE tO DST  ");
										break;
								case 1:
										fprintf(stdout, "AdMINISTRAtIVElY pROhIBITEd (FW)  ");
										break;
								case 2:
										fprintf(stdout, "NOT a NEiGHbOR  ");
										break;
								case 3:
										fprintf(stdout, "AddRESS UNREAChABlE  ");
										break;
								case 4:
										fprintf(stdout, "pORT UNREAChABlE  ");
										break;
						}
						break;
				case 2:
						fprintf(stdout, "pACkEt tOO BiG  ");
						break;
				case 3:
						fprintf(stdout, "TIME EXCEEDED: ");
						switch (icmp6->icmp6_code) {
								case 0:
										fprintf(stdout, "hOP LiMit EXCEEDED iN tRANSit  ");
										break;
								case 1:
										fprintf(stdout, "fRAGMENt REASSEMBlY tIME EXCEEDED  ");
										break;
						}
						break;
				case 4:
					 	fprintf(stdout, "PARAMEtER PROBlEM: ");
						switch (icmp6->icmp6_code) {
								case 0:
										fprintf(stdout, "ERRONEOUS hEADER fIElD  ");
										break;
								case 1:
										fprintf(stdout, "UNRECOGNiZED nEXt hEADER  ");
										break;
								case 2:
										fprintf(stdout, "UNRECOGNiZED OPtiON  ");
										break;
						}
						break;
				case 128:
						fprintf(stdout, "ECHO REQUESt  ");
						break;
				case 129:
						fprintf(stdout, "ECHO REPLY  ");
						break;
				case 130:
						fprintf(stdout, "gROUP MEMbERSHiP QUERY  ");
						break;
				case 131:
						fprintf(stdout, "gROUP MEMbERSHiP REPORt  ");
						break;
				case 132:
						fprintf(stdout, "gROUP MEMbERSHiP REDUCtiON  ");
						break;
				case 133:
						fprintf(stdout, "ROUtER SOLiCitATiON  ");
						break;
				case 134:
						fprintf(stdout, "ROUtER AdVERTiSEMENt  ");
						break;
				case 135:
						fprintf(stdout, "NEiGHbOR SOLiCitATiON  ");
						break;
				case 136:
						fprintf(stdout, "NEiGHbOR AdVERTiSEMENt  ");
						break;
				case 137:
						fprintf(stdout, "REDiRECt  ");
						break;
		}

		if (v) {
			//fprintf(stdout, "       ");
			fprintf(stdout, "<cODE: 0x%x ", icmp6->icmp6_code);
			fprintf(stdout, "sEq: 0x%x ", icmp6->icmp6_seq);
			fprintf(stdout, "iD: 0x%x ", icmp6->icmp6_id);
			fprintf(stdout, "Ck_SUM 0x%x>\n", icmp6->icmp6_cksum);
		}
		else fprintf(stdout, "\n");

		if(d)
			data_sniffo(data_info, ICMP6_HDR_LEN, stdout);
		if (x)
			print_ascii_hex(data_info, ICMP6_HDR_LEN, stdout);
	}
}
