/*
 *  Name: igmpsnf.c  [SNiFf]
 *  Date: Mon Aug 12 13:15:22 2001
 *  Author: uLiX [uLiX@gmx.it]
 *
 *  thnx to all my friends... That's all folk: No More Is Ash...
 *
 *  Tested on: DEBiAN GNU/LiNUX (Woody) kernel 2.4.5 on a i586
 */

#include "hdrsnf.h"
#include "pcksnf.h"
#include "igmpsnf.h"

void igmp_show (int v, int dUMP, int h)
{	
	tmp = time(NULL);
	strftime(datora, 60, "%T"/*[%D]"*/, localtime(&tmp));
/*** questa %T stampa il tempo al completo... aggiunta con C99 ***/
		
	igmp = (struct igmp *)(info_buf + sizeof(struct ip) + offset);
	ip   = (struct ip *)(info_buf + offset);
	
/***
	data_info = NULL;
	data_info = (char *)(info_buf + sizeof(struct ip)
									+ sizeof(struct igmp) + offset);
***/	
	hlen    = HDRLEN;
	len     = ntohs(ip->ip_len);
	tos     = ip->ip_tos;
	id      = ip->ip_id;
	frag    = ntohs(ip->ip_off);
	ttl     = ip->ip_ttl;

	saddr_ipv4 = (unsigned char *)inet_ntop(AF_INET, &ip->ip_src.s_addr,
												src_ipv4, sizeof(src_ipv4));
	daddr_ipv4 = (unsigned char *)inet_ntop(AF_INET, &ip->ip_dst.s_addr,
												dst_ipv4, sizeof(dst_ipv4));
	
  	if (dUMP) {

    	snprintf (name, sizeof(name), "%siGMP.lOg", DIRE);
    	log = fopen (name, "a");
 	
		if (!h)
			fprintf(log, "\n\n[IPv4] %s  fROM: %s >> tO: %s\n   ",
									datora, saddr_ipv4, daddr_ipv4);
		if (h)
			fprintf(log, "\n\n[IPv4] %s %s >> %s\n   ",
					datora, resolve_src(src_ipv4), resolve_dst(dst_ipv4));
		fprintf(log, "    lENGTH: %d  tOS: 0x%X  iD: %d  tTL: %d  ",
										             	len, tos, id, ttl);
		if (v) {
			if (frag & IP_RF)
				fprintf(log, "fRAG: RF (0x%x)  ", frag);
			else if (frag & IP_DF)
				fprintf(log, "fRAG: DF (0x%x)  ", frag);
			else if (frag & IP_MF)
				fprintf(log, "fRAG: MF (0x%x)  ", frag);
			else fprintf(log, "fRAG: 0x%x  ", frag);
		}
		//else fprintf(log, "\n");    /*** new line per igmp ***
		
		if ((hlen -= sizeof(struct ip)) > 0) {
			fprintf(log, "OPtlEN: %d  ", hlen);
			ippg_ops_show((u_char *)ip, hlen, log);
		}
		else fprintf(log, "\n");
		
		fprintf(log, "[iGMP] tYPE:  ");
		
     	switch(igmp->igmp_type) {
				case 0x11:
						fprintf(log, "MEMBERSHIP QUERY  ");
						break;
      			case 0x12:
						fprintf(log, "MEMBERSHIP REPORT (v1)  ");
						break;
      			case 0x13:
						fprintf(log, "DVMRP  ");
						break;
      			case 0x14:
						fprintf(log, "PIM  ");
						break;
     			case 0x15:
						fprintf(log, "TRACE  ");
						break; 
      			case 0x16:
						fprintf(log, "MEMBERSHIP REPORT (v2)  ");
						break;
      			case 0x17:
						fprintf(log, "LEAVE GROUP (v2)  ");
						break;
      			case 0x1e:
						fprintf(log, "MTRACE RESP  ");
						break;
      			case 0x1f:
						fprintf(log, "MTRACE  ");
						break;
      			default:
						fprintf(log, "UNkNOWN (%d)  ", igmp->igmp_type);
						break;
		}
		fprintf(log, "cODE: 0x%x  Ck_SUM: 0x%x\n", 
							igmp->igmp_code, igmp->igmp_cksum);
/***	
		if(d)
			data_sniffo(data_info, IGMP_HDR_LEN, log);
		if (x)
			print_ascii_hex(data_info, IGMP_HDR_LEN, log);		
***/		
		fclose (log);
	}
	
	if (!dUMP) {
 
		if (!h)
			fprintf(stdout, "\n\n[IPv4] %s  fROM: %s >> tO: %s\n   ",
									datora, saddr_ipv4, daddr_ipv4);
		if (h)	
			fprintf(stdout, "\n\n[IPv4] %s %s >> %s\n   ",
					datora, resolve_src(src_ipv4), resolve_dst(dst_ipv4));
		fprintf(stdout, "    lENGTH: %d  tOS: 0x%X  iD: %d  tTL: %d  ",
														len, tos, id, ttl);				if (v) {
			if (frag & IP_RF)
				fprintf(stdout, "fRAG: RF (0x%x)  ", frag);
			else if (frag & IP_DF)
				fprintf(stdout, "fRAG: DF (0x%x)  ", frag);
			else if (frag & IP_MF)
				fprintf(stdout, "fRAG: MF (0x%x)  ", frag);
			else fprintf(stdout, "fRAG: 0x%x  ", frag);
		}
		//else fprintf(stdout, "\n");    /*** new line per igmp ***/
		
		if ((hlen -= sizeof(struct ip)) > 0) {
			fprintf(stdout, "OPtlEN: %d  ", hlen);
			ippg_ops_show((u_char *)ip, hlen, stdout);
		}
		else fprintf(stdout, "\n");
			
		fprintf(stdout, "[iGMP] tYPE:  ");

		switch(igmp->igmp_type) {
				case 0x11:
						fprintf(stdout, "MEMBERSHIP QUERY  ");
	 	                break;
				case 0x12:
						fprintf(stdout, "MEMBERSHIP REPORT (v1)  ");
						break;
		        case 0x13:
				        fprintf(stdout, "DVMRP  ");
		                break;
	           	case 0x14:
                       fprintf(stdout, "PIM  ");
					   break;														          	case 0x15:
		              fprintf(stdout, "TRACE  ");
					  break;				     
			   	case 0x16:
                     fprintf(stdout, "MEMBERSHIP REPORT (v2)  ");
					 break;
			   	case 0x17:
					 fprintf(stdout, "LEAVE GROUP (v2)  ");
					 break;
				case 0x1e:
					 fprintf(stdout, "MTRACE RESP  ");
					 break;
				case 0x1f:
					 fprintf(stdout, "MTRACE  ");
				     break;
			    default:
					 fprintf(stdout, "UNkNOWN (%d)  ", igmp->igmp_type);
					 break;
		}
		fprintf(stdout, "cODE: 0x%x  Ck_SUM: 0x%x\n",
						igmp->igmp_code, igmp->igmp_cksum);
/***
		if(d)
			data_sniffo(data_info, IGMP_HDR_LEN, stdout);
		if (x)
			print_ascii_hex(data_info, IGMP_HDR_LEN, stdout);
***/						
	}
}
