/*
 *  Name: pcksnf.c  [SNiFf]
 *  Date: Mon Aug 12 15:10:19 2001
 *  Author: uLiX [uLiX@gmx.it]
 *
 *  thnx to all my friends... That's all folk: No More Is Ash...
 *
 *  Tested on: DEBiAN GNU/LiNUX (Woody) kernel 2.4.5 on a i586
 */

#include "hdrsnf.h"
#include "pcksnf.h"

int sniffo (int v, int d, int pROTO, int x, int dUMP, int h)
{
	bzero (&ip, sizeof(struct ip)); // reset della struct (?)
	
	ip  = (struct ip *)(info_buf + offset);   

	switch (VERSION) {
			case IPV4:
					ippg_show(v, d, pROTO, x, dUMP, h);
					break;
			case IPV6:
					ipng_show(v, d, pROTO, x, dUMP, h);
					break;
			default:
					fprintf(stdout, "HMMM... StRANGE iPv%d", VERSION);
					break;
	}
	return (0);
}

void ipng_show (int v, int d, int pROTO, int x, int dUMP, int h)
{
	tmp = time(NULL);
	strftime(datora, 60, "%T", localtime(&tmp));
		
	ip6 = (struct ip6_hdr *)(info_buf + offset);

	prty	=	ntohs(ip6->ip6_vfc);
	flow	=	ntohl(ip6->ip6_flow);
	plen	=	ntohs(ip6->ip6_plen);
	hlim    =   ip6->ip6_hlim;
	
	saddr_ipv6 = (char *)inet_ntop(AF_INET6, &ip6->ip6_src, 
											src_ipv6, sizeof(src_ipv6));
	daddr_ipv6 = (char *)inet_ntop(AF_INET6, &ip6->ip6_dst, 
											dst_ipv6, sizeof(dst_ipv6));
	
	cpy_hdr = (const u_char *)ip6;
	nxt_hdr = ip6->ip6_nxt;	
	
	/*** tcp/udp_show per stampare ip1.port1 >> ip2.port2 ***/
	if (nxt_hdr != IPPROTO_TCP && nxt_hdr != IPPROTO_UDP && 
					nxt_hdr != IPPROTO_ICMPV6) {
		
		if (dUMP) {
			snprintf (name, sizeof(name), "%sIPv6.lOg", DIRE);
			log = fopen (name, "a");
				
			if (!h)	
				fprintf(log, "\n\n[IPv6] %s fROM: %s >> tO: %s\n   ", 
								datora, saddr_ipv6, daddr_ipv6);
			if (h)
				fprintf(log, "\n\n[IPv6] %s %s >> %s\n   ",
						datora, resolve_src(src_ipv6), resolve_dst(dst_ipv6));
			fprintf(log, "    PRiORiTY: 0x%x  lENGTH: %d  HlIM: %d  ",
															prty, plen, hlim);
			if (v) {
				if (flow & PRI)
					fprintf(log, "pRI: 0x%x\n", (flow & PRI) >> 24);
				else if (flow & FLOW1)
					fprintf(log, "fLOW: 0x%x\n", (flow & FLOW2));
				else if (flow & CLASS)
					fprintf(log, "CLAsS: 0x%x\n", (flow & CLASS) >> 20);
				else if (flow & FLOW2)
					fprintf(log, "fLOW: 0x%x\n", (flow & FLOW2));
				else fprintf(log, "fLOW: 0x%x\n", flow);
			}
			else fprintf(log, "\n");
		}
		
		if (!dUMP) {
			if (!h)
				fprintf(stdout, "\n\n[IPv6] %s  fROM: %s >> tO: %s\n   ", 
								datora, saddr_ipv6, daddr_ipv6);
			if (h)
				fprintf(stdout, "\n\n[IPv6] %s  %s >> %s\n   ",
					datora, resolve_src(src_ipv6), resolve_dst(dst_ipv6));
			fprintf(stdout, "    PRiORiTY: 0x%x  lENGTH: %d  HlIM: %d  ",
														prty, plen, hlim);
			if (v) {
				if (flow & PRI)
					fprintf(stdout, "pRI: 0x%x\n", (flow & PRI) >> 24);
				else if (flow & FLOW1)
					fprintf(stdout, "fLOW: 0x%x\n", (flow & FLOW2));
				else if (flow & CLASS)
					fprintf(stdout, "CLAsS: 0x%x\n", (flow & CLASS) >> 20);
				else if (flow & FLOW2)
					fprintf(stdout, "fLOW: 0x%x\n", (flow & FLOW2));
				else fprintf(stdout, "fLOW: 0x%x\n", flow);
			}
			else fprintf(stdout, "\n");
			
		}
	} /*** fine nxt_hdr... ***/
	
    switch (nxt_hdr) {
				case IPPROTO_TCP:
						{
						if (pROTO == 0 || pROTO == 3) 	 
	    					tcpvsei_show(v, d, x, dUMP, h);
	  					break;
						}
        		case IPPROTO_UDP:
	  					if (pROTO == 0 || pROTO == 4) 	  
	    					udpvsei_show(v, d, x, dUMP, h);
	  					break;
        		case IPPROTO_ICMPV6:
	  					if (pROTO == 0 || pROTO == 1) 	  
	    					icmpvsei_show(v, d, x, dUMP, h);
	  					break;
				case IPPROTO_HOPOPTS:
						hop_show(cpy_hdr, dUMP);
						break;
				case IPPROTO_DSTOPTS:
						dst_show(cpy_hdr, dUMP);
						break;
				case IPPROTO_FRAGMENT:
						frag_show(cpy_hdr, dUMP);
						break;
				case IPPROTO_ROUTING:
						route_show(cpy_hdr, dUMP, h);
						break;
				case IPPROTO_IPV6:
						ipng_show(v, d, pROTO, x, dUMP, h);
						break;
				case IPPROTO_IPV4:
						ippg_show(v, d, pROTO, x, dUMP, h);
						break;
				case IPPROTO_NONE:
						nope_show(cpy_hdr, dUMP);
						break;
	        	default:
		  				break;
		}
}

void ippg_show (int v, int d, int pROTO, int x, int dUMP, int h)
{
	tmp = time(NULL);
	strftime(datora, 60, "%T", localtime(&tmp));

	ip = (struct ip *)(info_buf + offset);

	hlen	=	HDRLEN;
	len		=	ntohs(ip->ip_len);
	tos		=	ip->ip_tos;
	id		=	ip->ip_id;
	frag	=	ntohs(ip->ip_off);
	ttl		=	ip->ip_ttl;
	
	saddr_ipv4 = (unsigned char *)inet_ntop(AF_INET, &ip->ip_src.s_addr, 
											src_ipv4, sizeof(src_ipv4));
	daddr_ipv4 = (unsigned char *)inet_ntop(AF_INET, &ip->ip_dst.s_addr, 
											dst_ipv4, sizeof(dst_ipv4));
	
	nxt_prt = ip->ip_p;
	
	/*** tcp/udp_show per stampare ip1:port1 >> ip2:port2 ***/
	if (nxt_prt != IPPROTO_TCP && nxt_prt != IPPROTO_UDP &&
		nxt_prt != IPPROTO_ICMP && nxt_prt != IPPROTO_IGMP) {
							
		if (dUMP) {
			snprintf (name, sizeof(name), "%sIPv4.lOg", DIRE);
			log = fopen (name, "a");
			
			if (!h)
				fprintf(log, "\n\n[IPv4] %s  fROM: %s >> tO: %s\n   ", 
								datora, saddr_ipv4, daddr_ipv4);
			if (h)
				fprintf(log, "\n\n[IPv4] %s  %s >> %s\n   ",
					datora, resolve_src(src_ipv4), resolve_dst(dst_ipv4));
			fprintf(log, "    lENGTH: %d  tOS: 0x%x  iD: %d  tTL: %d  ",
														len, tos, id, ttl);
			if (v) {
				if (frag & IP_RF)
					fprintf(log, "fRAG: RF (0x%x)  ", frag);
				else if (frag & IP_DF)
					fprintf(log, "fRAG: DF (0x%x)  ", frag);
				else if (frag & IP_MF)
					fprintf(log, "fRAG: MF (0x%x)  ", frag);
				else fprintf(log, "fRAG: 0x%x  ", frag);
			}
				
			if ((hlen -= sizeof(struct ip)) > 0) {
				fprintf(log, "OPtlEN: %d  ", hlen);
				ippg_ops_show((u_char *)ip, hlen, log);
			}
			else fprintf(log, "\n");
		}
		if (!dUMP) {
			if (!h)
				fprintf(stdout, "\n\n[IPv4] %s  fROM: %s >> tO: %s\n   ",
								datora, saddr_ipv4, daddr_ipv4);
			if (h)
				fprintf(stdout, "\n\n[IPv4] %s  %s >> %s\n   ",
					datora, resolve_src(src_ipv4), resolve_dst(dst_ipv4));
			fprintf(stdout, "    lENGTH: %d  tOS: 0x%x  iD: %d  tTL: %d  ",
														len, tos, id, ttl);
			if (v) {
				if (frag & IP_RF)
					fprintf(stdout, "fRAG: RF (0x%x)  ", frag);
				else if (frag & IP_DF)
					fprintf(stdout, "fRAG: DF (0x%x)  ", frag);
				else if (frag & IP_MF)
					fprintf(stdout, "fRAG: MF (0x%x)  ", frag);
				else fprintf(stdout, "fRAG: 0x%x  ", frag);
			}
				
			if ((hlen -= sizeof(struct ip)) > 0) {
				fprintf(stdout, "OPtlEN: %d  ", hlen);
				ippg_ops_show((u_char *)ip, hlen, stdout);
			}
			else fprintf(stdout, "\n");
		}
	} /*** fine nh != IPPROTO_TCP... ***/
	switch (nxt_prt) {
				case IPPROTO_TCP:
						if (pROTO == 0 || pROTO == 3) 		
  							tcp_show(v, d, x, dUMP, h);
						break;
				case IPPROTO_UDP:
						if (pROTO == 0 || pROTO == 4) 		
		  					udp_show(v , d, x, dUMP, h);
						break;
    	 		case IPPROTO_ICMP:	
						if (pROTO == 0 || pROTO == 1) 	
	  						icmp_show(v, d, x, dUMP, h);
						break;
		      	case IPPROTO_IGMP:
						if (pROTO == 0 || pROTO == 2) 		
  							igmp_show(v, dUMP, h);         
						break;
			/*	case IP6PROTO_ENCAP:
						encap_show(v, dUMP);
						break;
			*/	default:
						break;
	}
}

/*** testing - se non va, per favore email <uLiX@gmx.it> ***/
void ippg_ops_show (u_char *ip, int header_len, FILE *output)
{
	for (; header_len > 0; ip += hdr_len, header_len -= hdr_len) {
			
		opts = *ip;
		
		switch (opts) {
				case IPOPT_EOL:
						fprintf(output, "EOL");
						break;
				case IPOPT_NOP:
						fprintf(output, "NOP");
						break;
				/*** magari quaesta option la guardo 
				   piu' in la' (vedi tcpdump)     ***/		
				case IPOPT_TS:
						fprintf(output, "TS");
						break;
				case IPOPT_SECURITY:
						fprintf(output, "SECURITY");
						break;
				case IPOPT_RR:
						fprintf(output, "RR");
						break;
				case IPOPT_SSRR:
						fprintf(output, "SSRR");
						break;
				case IPOPT_LSRR:
						fprintf(output, "LSRR");
						break;
				case IPOPT_RA:
						fprintf(output, "RA");
						break;
				default:
						fprintf(output, " ");
						break;
		}
	}
}
