/*
 *  Name: printsnf.c  [SNiFf]
 *  Date: Mon Aug 12 13:16:38 2001
 *  Author: uLiX [uLiX@gmx.it]
 *
 *  thnx to all my friends... That's all folk: No More Is Ash...
 *
 *  Tested on: DEBiAN GNU/LiNUX (Woody) kernel 2.4.5 on a i586
 */

#include "hdrsnf.h"
#include "printsnf.h"
#include "utlssnf.h"

void print_ascii_hex(char *data, u_int l, FILE *log)
{
	u_int offset; 
	u_int i;
	int s1, s2;
	int nshorts;
	char hex[BYTES*DIGITS+1], *hsp;
	char ascii[BYTES+1], *asp;
	offset = 0;
	
	nshorts = l / sizeof(u_short);
	i = 0;
	hsp = hex; asp = ascii;
	while (--nshorts >= 0) {
		s1 = *data++;
		s2 = *data++;
		(void)snprintf(hsp, sizeof(hex) - (hsp - hex),
		    " %02x%02x", s1, s2);
		hsp += DIGITS;
		*(asp++) = (isgraph(s1) ? s1 : '.');
		*(asp++) = (isgraph(s2) ? s2 : '.');
		if (++i >= SHORTS) {
		    *hsp = *asp = '\0';
		    fprintf(log, "\n0x%04x   %-*s    %s",
				 offset, LINE,
				 hex, ascii);
		    i = 0; hsp = hex; asp = ascii;
		    offset += BYTES;
		}
	}
	if (l & 1) {
		s1 = *data++;
		(void)snprintf(hsp, sizeof(hex) - (hsp - hex),
		    " %02x", s1);
		hsp += 3;
		*(asp++) = (isgraph(s1) ? s1 : '.');
		++i;
	}
	if (i > 0) {
		*hsp = *asp = '\0';
		fprintf(log, "\n0x%04x   %-*s    %s",
			     offset, LINE,
			     hex, ascii);
	}
}

void data_sniffo (char *data_info, u_int len, FILE *log)
{
	int     i, y = 0;
	char    dst[B_SIZE];

	bzero (dst, sizeof(dst));

	if (data_info == NULL)
		fprintf(log, "NULL DaTA...\n\n");

	for (i = 0; i < len; i++) {

		if (isprint (data_info[i]))
			dst[i] = data_info[i];
		else if (dst[i] == '\n' || dst[i] == '\r')
	        	dst[i] = '\n';
		else if (dst[i] == ' ')		/*** cosi' manteniamo gli spazi... ***/
				dst[i] = ' ';
		else
	        dst[i] = '.';
	}

	for (i = 0; i < strlen(dst); i++) {
		fputc(dst[i], log);
       	if (i == y) {
			fputc('\n', log);
	       	y += TTYLINE;
		}
	}
}

/***
void data_sniffo_sei (char *data_info, u_int len, FILE *log)
{
	int     i, y = 0;
	char    dst[B_SIZE];

	bzero (dst, sizeof(dst));
	
	if (data_info == NULL)
		fprintf(log, "NULL DaTA...\n\n");
	   
	for (i = 0; i < len; i++) {
			    
		if (isprint (data_info[i]))
			dst[i] = data_info[i];
		else if (dst[i] == '\n' || dst[i] == '\r')
			dst[i] = '\n';	
		else
			dst[i] = '.';			
	}

	for (i = 0; i < strlen(dst); i++) {
		fputc(dst[i], log);
		if (i == y) {
			fputc('\n', log);
			y += TTYLINE;	
		}	
	}
}
***/
