/*
 *  Name: tcpsnf.c  [SNiFf]
 *  Date: Mon Aug 12 13:16:59 2001
 *  Author: uLiX [uLiX@gmx.it]
 *
 *  thnx to all my friends... That's all folk: No More Is Ash...
 *
 *  Tested on: DEBiAN GNU/LiNUX (Woody) kernel 2.4.5 on a i586
 */

#include "hdrsnf.h"
#include "tcpsnf.h"
#include "utlssnf.h"

void tcp_show (int v, int d, int x, int dUMP, int h)
{	
	tmp = time(NULL);
  	strftime(datora, 60, "%T"/*[%D]"*/, localtime(&tmp));
/*** questa %T stampa il tempo al completo... aggiunta con C99 ***/
	
	tcp = (struct tcphdr *)(info_buf + sizeof(struct ip) + offset);
	ip 	= (struct ip *)(info_buf + offset);
	
	data_info = NULL;		/*** puntatore azzerato (?) ***/
	data_info = (char *)(info_buf + sizeof(struct ip) + sizeof(struct tcphdr)
					+ offset);
	
	hlen	=	HDRLEN;
	len		=	ntohs(ip->ip_len);
	tos		=	ip->ip_tos;	
	id		=	ip->ip_id;
	frag	=	ntohs(ip->ip_off);	
	ttl		=	ip->ip_ttl;

	saddr_ipv4 = (unsigned char *)inet_ntop(AF_INET, &ip->ip_src.s_addr,
				                                   	src_ipv4, sizeof(src_ipv4));
	daddr_ipv4 = (unsigned char *)inet_ntop(AF_INET, &ip->ip_dst.s_addr,
													dst_ipv4, sizeof(dst_ipv4));
	t_hlen	=	TCPHLEN;
	sport 	= 	ntohs(tcp->source);
	dport	=	ntohs(tcp->dest);
	seq		=	ntohl(tcp->seq);
	ack_seq	=	ntohl(tcp->ack_seq);
	window	=	ntohs(tcp->window);
	
  	if (dUMP) {
    	snprintf (name, sizeof(name), "%stCP.lOg", DIRE);
    	log = fopen (name, "a");

		if (!h)
			fprintf(log, "\n\n[IPv4] %s  fROM: %s:%d >> tO: %s:%d\n   ",
							datora, saddr_ipv4, sport, daddr_ipv4, dport);
		if (h)
			fprintf(log, "\n\n[IPv4] %s %s|%s >> %s|%s\n   ",
					datora, resolve_src(src_ipv4), resolve_port_src(sport),
						resolve_dst(dst_ipv4), resolve_port_dst(dport));
		fprintf(log, "    lENGTH: %d  tOS: 0x%X  iD: %d  tTL: %d  ",
							len, tos, id, ttl);
		if (v) {
			if (frag & IP_RF)
				fprintf(log, "fRAG: RF (0x%x)  ", frag);
			else if (frag & IP_DF)
				fprintf(log, "fRAG: DF (0x%x)  ", frag);
			else if (frag & IP_MF)
			    fprintf(log, "fRAG: MF (0x%x)  ", frag);
			else fprintf(log, "fRAG: 0x%x  ", frag);
		}
		//else fprintf(log, "\n");    /*** new line per tcp ***/
			
		if ((hlen -= sizeof(struct ip)) > 0) {
			fprintf(log, "OPtlEN: %d  ", hlen);
			ippg_ops_show((u_char *)ip, hlen, log);
		}
		else fprintf(log, "\n");		
		
		fprintf (log, "[tCP]  fLAgS: %c%c%c%c%c%c  ",
	 		(tcp->syn == 1)?'S':'-', (tcp->ack == 1)?'A':'-',
	 		(tcp->fin == 1)?'F':'-', (tcp->rst == 1)?'R':'-',
			(tcp->psh == 1)?'P':'-', (tcp->urg == 1)?'U':'-');
		fprintf(log, "WiN: %d  SEq: 0x%X  ACk_SEq: 0x%X\n",
											window, seq, ack_seq);

		if (d)
			data_sniffo(data_info, TCP_HDR_LEN, log);
		if (x)
			print_ascii_hex(data_info, TCP_HDR_LEN, log);

		fclose (log);
	}
	if (!dUMP) {
		if (!h)
			fprintf(stdout, "\n\n[IPv4] %s  fROM: %s:%d >> tO: %s:%d\n   ",
					datora, saddr_ipv4, sport, daddr_ipv4, dport);
		if (h)
			fprintf(stdout, "\n\n[IPv4] %s %s|%s >> %s|%s\n   ",
					datora, resolve_src(src_ipv4), resolve_port_src(sport),
						resolve_dst(dst_ipv4), resolve_port_dst(dport));
		fprintf(stdout, "    lENGTH: %d  tOS: 0x%X  iD: %d  tTL: %d  ",
												len, tos, id, ttl);
		if (v) {
			if (frag & IP_RF)
				fprintf(stdout, "fRAG: RF (0x%x)  ", frag);
			else if (frag & IP_DF)
				fprintf(stdout, "fRAG: DF (0x%x)  ", frag);
			else if (frag & IP_MF)	
				fprintf(stdout, "fRAG: MF (0x%x)  ", frag);	
			else fprintf(stdout, "fRAG: 0x%x  ", frag);
		}
		//else fprintf(log, "\n");    /*** new line per tcp ***/

		if ((hlen -= sizeof(struct ip)) > 0) {
			fprintf(stdout, "OPtlEN: %d  ", hlen);
			ippg_ops_show((u_char *)ip, hlen, stdout);
		}
		else fprintf(stdout, "\n");

		fprintf (stdout, "[tCP]  fLAgS: %c%c%c%c%c%c  ",
			(tcp->syn == 1)?'S':'-', (tcp->ack == 1)?'A':'-',
			(tcp->fin == 1)?'F':'-', (tcp->rst == 1)?'R':'-',
			(tcp->psh == 1)?'P':'-', (tcp->urg == 1)?'U':'-');
		fprintf(stdout, "WiN: %d  SEq: 0x%X  ACk_SEq: 0x%X\n",
											window, seq, ack_seq);

		if (d)
			data_sniffo(data_info, TCP_HDR_LEN, stdout);
		if (x)
			print_ascii_hex(data_info, TCP_HDR_LEN, stdout);
	}
}
