/*
 *  Name: tcpv6snf.c  [SNiFf]
 *  Date: Mon Aug 12 13:16:59 2001
 *  Author: uLiX [uLiX@gmx.it]
 *
 *  thnx to all my friends... That's all folk: No More Is Ash...
 *
 *  Tested on: DEBiAN GNU/LiNUX (Woody) kernel 2.4.5 on a i586
 */

#include "hdrsnf.h"
#include "tcpv6snf.h"
#include "utlssnf.h"

void tcpvsei_show (int v, int d, int x, int dUMP, int h)
{	
	tmp = time(NULL);
  	strftime(datora, 60, "%T"/*[%D]"*/, localtime(&tmp));
/*** questa %T stampa il tempo al completo... aggiunta con C99 ***/
	
	tcp = (struct tcphdr *)(info_buf + sizeof(struct ip6_hdr) + offset);
	ip6 = (struct ip6_hdr *)(info_buf + offset);
	
	data_info = NULL;		/*** puntatore azzerato (?) ***/
	data_info = (char *)(info_buf + sizeof(struct ip6_hdr) + 
					sizeof(struct tcphdr) + offset);
	
	prty    =	ntohs(ip6->ip6_vfc);
	flow    =	ntohl(ip6->ip6_flow);
	plen    =	ntohs(ip6->ip6_plen);
	hlim    =   ip6->ip6_hlim;

	saddr_ipv6 = (unsigned char *)inet_ntop(AF_INET6, &ip6->ip6_src,
												src_ipv6, sizeof(src_ipv6));
	daddr_ipv6 = (unsigned char *)inet_ntop(AF_INET6, &ip6->ip6_dst,
												dst_ipv6, sizeof(dst_ipv6));
	sport 	= 	ntohs(tcp->source);
	dport	=	ntohs(tcp->dest);
	seq		=	ntohl(tcp->seq);
	ack_seq	=	ntohl(tcp->ack_seq);
	window	=	ntohs(tcp->window);
	
  	if (dUMP) {
    	snprintf (name, sizeof(name), "%stCPv6.lOg", DIRE);
    	log = fopen (name, "a");

		if (!h)
			fprintf(log, "\n\n[IPv6] %s  fROM: %s.%d >> tO: %s.%d\n   ",
							datora, saddr_ipv6, sport, daddr_ipv6, dport);
		if (h)
			fprintf(log, "\n\n[IPv6] %s %s|%s >> %s|%s\n   ",
					datora, resolve_src(src_ipv6), resolve_port_src(sport),
						resolve_dst(dst_ipv6), resolve_port_dst(dport));
		fprintf(log, "PRiORiTY: 0x%x  lENGTH: %d  HlIM: %d  ",
													prty, plen, hlim);
		if (v) {
			if (flow & PRI)
				fprintf(log, "pRI: 0x%x\n", (flow & PRI) >> 24);
			else if (flow & FLOW1)
				fprintf(log, "fLOW: 0x%x\n", (flow & FLOW2));
			else if (flow & CLASS)
				fprintf(log, "CLAsS: 0x%x\n", (flow & CLASS) >> 20);
			else if (flow & FLOW2)
				fprintf(log, "fLOW: 0x%x\n", (flow & FLOW2));
			else fprintf(log, "fLOW: 0x%x\n", flow);
		}
		else fprintf(log, "\n");	/*** new line per tcp ***/
		
		fprintf (log, "[tCP]  fLAgS: %c%c%c%c%c%c  ",
	 		(tcp->syn == 1)?'S':'-', (tcp->ack == 1)?'A':'-',
	 		(tcp->fin == 1)?'F':'-', (tcp->rst == 1)?'R':'-',
			(tcp->psh == 1)?'P':'-', (tcp->urg == 1)?'U':'-');
		fprintf(log, "WiN: %d  SEq: 0x%X  ACk_SEq: 0x%X\n",
											window, seq, ack_seq);	
		if (d)
			data_sniffo(data_info, TCP6_HDR_LEN, log);
		if (x)
			print_ascii_hex(data_info, TCP6_HDR_LEN, log);

		fclose (log);
	}
	if (!dUMP) {
		if (!h)
			fprintf(stdout, "\n\n[IPv6] %s  fROM: %s:%d >> tO: %s:%d\n   ",
					datora, saddr_ipv6, sport, daddr_ipv6, dport);
		if (h)
			fprintf(stdout, "\n\n[IPv6] %s %s|%s >> %s|%s\n   ",
					datora, resolve_src(src_ipv6), resolve_port_src(sport),
						resolve_dst(dst_ipv6), resolve_port_dst(dport));
		fprintf(stdout, "    PRiORiTY: 0x%x  lENGTH: %d  HlIM: %d  ",
													prty, plen, hlim);
		if (v) {
			if (flow & PRI)
				fprintf(stdout, "pRI: 0x%x\n", (flow & PRI) >> 24);
			else if (flow & FLOW1)	
				fprintf(stdout, "fLOW: 0x%x\n", (flow & FLOW2));
			else if (flow & CLASS)
				fprintf(stdout, "CLAsS: 0x%x\n", (flow & CLASS) >> 20);
			else if (flow & FLOW2)
				fprintf(stdout, "fLOW: 0x%x\n", (flow & FLOW2));
			else fprintf(stdout, "fLOW: 0x%x\n", flow);
		}
		else fprintf(stdout, "\n");    /*** new line per tcp ***/
		
		fprintf (stdout, "[tCP]  fLAgS: %c%c%c%c%c%c  ",
			(tcp->syn == 1)?'S':'-', (tcp->ack == 1)?'A':'-',
			(tcp->fin == 1)?'F':'-', (tcp->rst == 1)?'R':'-',
			(tcp->psh == 1)?'P':'-', (tcp->urg == 1)?'U':'-');
		fprintf(stdout, "WiN: %d  SEq: 0x%X  ACk_SEq: 0x%X\n",
											window, seq, ack_seq);

		if (d)
			data_sniffo(data_info, TCP6_HDR_LEN, stdout);
		if (x)
			print_ascii_hex(data_info, TCP6_HDR_LEN, stdout);
	}
}
