/*
 *  Name: udpsnf.c  [SNiFf]
 *  Date: Mon Aug 12 13:17:38 2001
 *  Author: uLiX [uLiX@gmx.it]
 *
 *  thnx to all my friends... That's all folk: No More Is Ash...
 *
 *  Tested on: DEBiAN GNU/LiNUX (Woody) kernel 2.4.5 on a i586
 */

#include "hdrsnf.h"
#include "utlssnf.h"
#include "udpv6snf.h"

void udpvsei_show (int v, int d, int x, int dUMP, int h) 
{
	tmp = time(NULL);
	strftime(datora, 60, "%T"/*[%D]"*/, localtime(&tmp));
/*** questa %T stampa il tempo al completo... aggiunta con C99 ***/

	udp = (struct udphdr *)(info_buf + sizeof(struct ip6_hdr) + offset);
	ip6  = (struct ip6_hdr *)(info_buf + offset);

	data_info = NULL;       /*** puntatore azzerato (?) ***/
	data_info = (char *)(info_buf + sizeof(struct ip6_hdr) 
												+ sizeof(struct udphdr)
											                    + offset);

	prty    =   ntohs(ip6->ip6_vfc);
	flow    =   ntohl(ip6->ip6_flow);
	plen    =   ntohs(ip6->ip6_plen);
	hlim    =   ip6->ip6_hlim;

	saddr_ipv6 = (unsigned char *)inet_ntop(AF_INET6, &ip6->ip6_src,
												src_ipv6, sizeof(src_ipv6));
	daddr_ipv6 = (unsigned char *)inet_ntop(AF_INET6, &ip6->ip6_dst,
												dst_ipv6, sizeof(dst_ipv6));

	sport   =   ntohs(udp->source);
	dport   =   ntohs(udp->dest);
	udp_len	=	udp->len;
	check	=	udp->check;
													
	if (dUMP) {

    	snprintf (name, sizeof(name), "%suDP.lOg", DIRE);
    	log = fopen (name, "a");
    	
		if (!h)
			fprintf(log, "\n\n[IPv6] %s  fROM: %s:%d >> tO: %s:%d\n   ",
						datora, saddr_ipv6, sport, daddr_ipv6, dport);
		if (h)
			fprintf(log, "\n\n[IPv6] %s %s|%s >> %s|%s\n   ",
				datora, resolve_src(src_ipv6), resolve_port_src(sport),
					resolve_dst(dst_ipv6), resolve_port_dst(dport));
		fprintf(log, "PRiORiTY: 0x%x  lENGTH: %d  HlIM: %d  ",
						     							prty, plen, hlim);
		if (v) {
			if (flow & PRI)
				fprintf(log, "pRI: 0x%x\n", (flow & PRI) >> 24);
			else if (flow & FLOW1)
				fprintf(log, "fLOW: 0x%x\n", (flow & FLOW2));
			else if (flow & CLASS)
				fprintf(log, "CLAsS: 0x%x\n", (flow & CLASS) >> 20);
			else if (flow & FLOW2)
				fprintf(log, "fLOW: 0x%x\n", (flow & FLOW2));
			else fprintf(log, "fLOW: 0x%x\n", flow);
		}
		else fprintf(log, "\n");
		
		fprintf (log, "[UDP]  hDR lENGTH: 0x%x  Ck_SUM 0x%x", udp_len, check);

		if (d)
			data_sniffo(data_info, UDP6_HDR_LEN, log);
		if (x)
			print_ascii_hex(data_info, UDP6_HDR_LEN, log);

		fclose (log);
	}					
												
	if (!dUMP) {
    	
		if (!h)
			fprintf(stdout, "\n\n[IPv6] %s  fROM: %s:%d >> tO: %s:%d\n   ",
						datora, saddr_ipv6, sport, daddr_ipv6, dport);
		if (h)
			fprintf(stdout, "\n\n[IPv6] %s %s|%s >> %s|%s\n   ",
				datora, resolve_src(src_ipv6), resolve_port_src(sport),
					resolve_dst(dst_ipv6), resolve_port_dst(dport));
		fprintf(stdout, "PRiORiTY: 0x%x  lENGTH: %d  HlIM: %d  ",
														prty, plen, hlim);
		if (v) {
			if (flow & PRI)
				fprintf(stdout, "pRI: 0x%x\n", (flow & PRI) >> 24);
			else if (flow & FLOW1)
				fprintf(stdout, "fLOW: 0x%x\n", (flow & FLOW2));
			else if (flow & CLASS)
				fprintf(stdout, "CLAsS: 0x%x\n", (flow & CLASS) >> 20);
			else if (flow & FLOW2)
				fprintf(stdout, "fLOW: 0x%x\n", (flow & FLOW2));
			else fprintf(stdout, "fLOW: 0x%x\n", flow);
		}
		else fprintf(stdout, "\n");
		
		fprintf (stdout, "[UDP]  hDR lENGTH: 0x%x  Ck_SUM 0x%x", udp_len, check);

		if (d)
			data_sniffo(data_info, UDP6_HDR_LEN, stdout);
		if (x)
			print_ascii_hex(data_info, UDP6_HDR_LEN, stdout);
	}
}
