/*
 *  Name: utlssnf.c  [SNiFf]
 *  Date: Mon Aug 12 13:18:08 2001
 *  Author: uLiX [uLiX@gmx.it]
 *
 *  thnx to all my friends... That's all folk: No More Is Ash...
 *
 *  Tested on: DEBiAN GNU/LiNUX (Woody) kernel 2.4.5 on a i586
 */

#include "hdrsnf.h"
#include "utlssnf.h"

void pcap_device_on (int p, int v, int d, int proto, int ext, int dUMP, int h)
{	
	char err[400];			/*** error buffer... ***/
	
	if (name_face == NULL) {
		if ((name_face = pcap_lookupdev(err)) == NULL) {
			fprintf(stderr, "pcap_lookupdev: %s\n", err);
		    exit(0);
		}
	}
  
  	if (p) { 
    	if ((pcap_src = pcap_open_live (name_face, MAX_SIZE, 1, 0, err)) 
																== NULL) {
      		fprintf(stderr, "pcap_open_live: %s\n", err);
      		exit(0);
    	}	
  	}
  	else
    	if ((pcap_src = pcap_open_live (name_face, MAX_SIZE, 0, 0, err)) 
																== NULL) {
      		fprintf(stderr, "pcap_open_live: %s\n", err);
      		exit(0);
    	}
 
  	if ((datalink = pcap_datalink(pcap_src)) < 0) {
    	fprintf(stderr, "pcap_datalink: %s\n", err);
    	exit(0);    
  	}
  	switch (datalink) {
    	case DLT_EN10MB:
      		offset = 14;
      		break;
    	case DLT_NULL:
    	case DLT_PPP:	
      		offset = 4;
      		break;
    	case DLT_SLIP:
      		offset = 16;
      		break;
    	case DLT_RAW:
      		offset = 0;
      		break;
    	case DLT_SLIP_BSDOS:
    	case DLT_PPP_BSDOS:
      		offset = 24;
      		break;
    	default:
      		fprintf(stderr, "UNkNOWN DATALiNk TyPE (%d)", datalink);
      		exit(-1); 
  	}
	fprintf(stdout, 
			"\n\e[0;35m%s\e[0m LiSTENiNG on \e[0;35m%s\e[0m INtERfACE\n\n",
														p_name, name_face);

  	while (1) {    
    	info_buf = (u_char *)pcap_next(pcap_src, &hdr);
    	if (info_buf != NULL) 
       		sniffo(v, d, proto, ext, dUMP, h);
	}

}

void pcap_device_off ()
{

  	if (pcap_stats(pcap_src, &status) < 0)
    	fprintf (stderr, "pcap_stats: %s\n", pcap_geterr(pcap_src));

  	fprintf (stdout, "\n\n\nPACkEtS RECEiVED: \e[0;35m%d\e[0m\n", 
															status.ps_recv);
  	fprintf (stdout, "PACkEtS DR0PPED by kERNEl: \e[0;35m%d\e[0m\n", 
															  status.ps_drop);

  	fprintf (stdout, "\e[0;35m\n\nbye, BYEZ...\n\n\e[0m");
  	exit(0);
}

/***
 risolve source portname
 			  		 ***/
char *resolve_port_src(u_int port) 
{
	static char	src_port[10];
	static struct servent *se;

	se = getservbyport(htons(port), NULL);

	if (!se) {
		sprintf(src_port, "%u", port);
		return (src_port);
	} 
	else {
		strncpy(src_port, se->s_name, 10);
		return(src_port);
	}
}

/***
 risolve destination portname
                          ***/
char *resolve_port_dst(u_int port)
{
	static char	dst_port[10]; 
	static 	struct servent *se;

	se = getservbyport(htons(port), NULL);

	if (!se) {
		sprintf(dst_port, "%u", port);
		return (dst_port);
	} 
	else {
		strncpy(dst_port, se->s_name, 10);
		return(dst_port);
	}
}

/*** 
 risolve source address 
 					***/
char *resolve_src (char *name)
{
	static char remote_host_src[NI_MAXHOST];
	struct addrinfo info, *info2;
	int a, n;

	bzero(&info, sizeof(info));         // si DEVE settare a zero
					                    // l' ai.flags...

	if ((a = getaddrinfo(name, NULL, &info, &info2)) != 0) {
		fprintf (stderr, "getaddrinfo error: %s\n", gai_strerror(a));
		exit(0);
	}
	
	if ((n = getnameinfo(info2->ai_addr, info2->ai_addrlen, remote_host_src,
				sizeof(remote_host_src), NULL, 0, 0)) != 0) {
		fprintf (stderr, "getnameinfo error: %s\n", gai_strerror(n));
		exit(0);
	}
	return (remote_host_src);
}

/***
 risolve destination address
 						 ***/
char *resolve_dst (char *name)
{
	static char remote_host_dst[NI_MAXHOST];	
	struct addrinfo info, *info2;
	int a, n;
		
	bzero(&info, sizeof(info));  	     // si DEVE settare a zero
					                     // l' ai.flags...

	if ((a = getaddrinfo(name, NULL, &info, &info2)) != 0) {
		fprintf (stderr, "getaddrinfo error: %s\n", gai_strerror(a));
		exit(0);
	}
	if ((n = getnameinfo(info2->ai_addr, info2->ai_addrlen, remote_host_dst,
						sizeof(remote_host_dst), NULL, 0, 0)) != 0) {
		fprintf (stderr, "getnameinfo error: %s\n", gai_strerror(n));
		exit(0);
	}
	return (remote_host_dst);
}
